/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    File        :    dpr.h

    Date        :   30-06-94
    Version     :   1

    Auteur      :   BEAURIN oliver

\*********************************************************************/

#ifndef DPP_H
#define DPP_H

/*---------------------------------------------------------\
                    defines
\---------------------------------------------------------*/
#define VERBOSE_NORMAL 1
#define VERBOSE_ALL    2

/*---------------------------------------------------------\
                     structures
\---------------------------------------------------------*/
/*
 * PATCH AsGa : Parametrage de la technologie.
 */

typedef struct {
	char  LAYER_ALIM;  /* Layer des alimentations.   */
	long   TOP_TRACK;  /* Derniere piste (sous VDD). */
	long   BOT_TRACK;  /* Premiere piste (sur  VSS). */
	} DPR_Var_t;

/*---------------------------------------------------------\
                     externs
\---------------------------------------------------------*/
extern char verbose_mode;
extern char debug_mode;
extern DPR_Var_t  DPR_Var;

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/
  /*#ifdef __STDC__

extern void savephfig     ( void * );
extern void savelofig     ( void * );
extern void unflattenlofig( void *, char *, char *, void * );
extern void rflattenphfig ( void *, char, char );

#else

extern void savephfig     ( );
extern void savelofig     ( );
extern void unflattenlofig( );
extern void rflattenphfig ( );

#endif*/

#define TRUE  1
#define FALSE 0

#endif
