/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Message.c                        |
|                                                             |
| Author  :                Jacomme Ludovic                    |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/PushBG.h>
# include <Xm/CascadeBG.h>
 
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RFM_H
# include GRD_H
# include GMX_H
# include GTB_H
# include GSB_H
# include GMC_H
# include "GMC_message.h"
# include "GMC_create.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char MessageBuffer[ 512 ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    DrealPromptCreateRectangle               |
|                                                             |
\------------------------------------------------------------*/

void DrealPromptCreateRectangle()

{
  char StaticLayer;

  StaticLayer = RDS_STATIC_LAYER[ DrealRectangleLayer ];

  DrealDisplayMessage( DREAL_MESSAGE_MODE, "Create Rectangle" );

  if ( DrealRectangleName == (char *)NULL )
  {
    sprintf( MessageBuffer, "Layer: %s   Name: none",
             DREAL_RDS_LAYER_NAME_TABLE[ StaticLayer ][0] );
  }
  else
  {
    sprintf( MessageBuffer, "Layer: %s   Name: %s",
             DREAL_RDS_LAYER_NAME_TABLE[ StaticLayer ][0] ,
             DrealRectangleName );
  }

  DrealDisplayMessage( DREAL_MESSAGE_INFO, MessageBuffer );

  switch ( DrealCountEventEdit )
  {
    case 0 : 

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter first point" );

    break;

    case 1 :

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter second point" );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    DrealPromptCreateAbutmentBox             |
|                                                             |
\------------------------------------------------------------*/
 
void DrealPromptCreateAbutmentBox()
 
{
  DrealDisplayMessage( DREAL_MESSAGE_MODE, "Create Abutmentbox" );
  DrealDisplayMessage( DREAL_MESSAGE_INFO, "Select window" );
 
  switch ( DrealCountEventEdit )
  {
    case 0 :
 
      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter first corner" );
 
    break;

    case 1 :
 
      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter second corner" );
  } 
}
