/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  GMV101.h                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef DREAL_GMV
# define DREAL_GMV 

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern char DrealFirstViewLayer;

/*------------------------------------------------------------\
|                                                             |
|                        Panel And Menu                       |
|                                                             |
\------------------------------------------------------------*/

  extern DrealMenuItem  DrealViewMenu[];
  extern DrealPanelItem DrealViewArrowsPanel;
  extern DrealPanelItem DrealViewZoomPanel;
  extern DrealPanelItem DrealViewGridPanel;
  extern DrealPanelItem DrealViewLayerPanel;
  extern DrealPanelItem DrealViewMapPanel;
 
  extern int  DrealPercentZoom;
  extern int  DrealPercentMove;

  extern int  DrealViewArrowsDefaultValues[5];
  extern int  DrealViewZoomDefaultValues[5];
  extern int  DrealViewLayerDefaultValues[5];
  extern int  DrealViewGridDefaultValues[5];
  extern int  DrealViewMapDefaultValues[5];
  
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Callback                           |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Zoom                             |
|                                                             |
\------------------------------------------------------------*/

  extern void DrealComputeAndDisplayMap();
  extern void DrealInitializeZoom();
  extern void DrealBuildViewDialog();
  extern void DrealBuildPanelLayer();
  extern void DrealBuildPanelMap();
  extern void DrealInitializeMapEvent();


  extern void DrealZoomUndo();
  extern void DrealZoomLeft();
  extern void DrealZoomRight();
  extern void DrealZoomUp();
  extern void DrealZoomDown();
  extern void DrealZoomMore();
  extern void DrealZoomLess();
  extern void DrealZoomFit();
  extern void DrealZoomCenter();
  extern void DrealZoomRefresh();
  extern void DrealZoomIn();
  extern void DrealZoomPan();

  extern void DrealPromptZoomIn();
  extern void DrealPromptZoomPan();
  extern void DrealPromptZoomCenter();

# endif
