/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                   Map.h                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef DREAL_MAP
# define DREAL_MAP

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define DREAL_B1UP   0
# define DREAL_B2UP   1
# define DREAL_B3UP   2

# define DREAL_VIEW_MAP_X        25
# define DREAL_VIEW_MAP_Y       520

# define DREAL_DEFAULT_MAP_X      0
# define DREAL_DEFAULT_MAP_Y      0
# define DREAL_DEFAULT_MAP_DX    40
# define DREAL_DEFAULT_MAP_DY    40

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
 
  extern Widget DrealMapPanel;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void DrealComputeLambdaMap();
  extern void DrealInitializeLambdaMap();
  extern void DrealDisplayLambdaMap();

  extern void DrealEnterMapPanel();
  extern void DrealClearMapWindow();
  extern void DrealResizeMapWindow();
  extern void DrealRefreshMapWindow();
  extern void DrealInitializeMapWindow();

  extern void CallbackCloseMap();
  extern void CallbackMapResize();
  extern void CallbackMapExpose();
  extern void CallbackMapEvent();

# endif 
