/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Cursor.h                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef DREAL_CURSOR
# define DREAL_CURSOR

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define DREAL_MAX_CURSOR_BUFFER 128

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern Position DrealCursorX;
  extern Position DrealCursorY;
  extern Position DrealCursorSaveX;
  extern Position DrealCursorSaveY;
  extern char     DrealCursorSaved;
  extern char     DrealCursorInside;
  extern long     DrealLambdaCursorX;
  extern long     DrealLambdaCursorY;

  extern long     DrealPixelCursorX;
  extern long     DrealPixelCursorY;

  extern long     DrealPixelCursorX1;
  extern long     DrealPixelCursorY1;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void DrealComputeCursor();
  extern void DrealChangeCursorType();
  extern void DrealPointCursor();
  extern void DrealResetCursor();
  extern void DrealDisplayCoordinates();
  
# endif 
