/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Motif.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
# include <Xm/MainW.h>
 
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include GTB_H
# include GSB_H
# include GMX_H
# include GMS_H

# include "GMX_motif.h"
# include "GMX_graphic.h" 
# include "GMX_event.h" 
# include "GMX_message.h" 
# include "GMX_menu.h" 
# include "GMX_color.h" 
# include "GMX_panel.h"
# include "GMX_dialog.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  XtAppContext  DrealApplication;
  Widget        DrealTopLevel;
  Widget        DrealMainWindow;
  Widget        DrealMainForm;
 
  static String DrealFallBacks [] =

         {
           "*.DrealMainWindow.iconName : Dreal",
           "*DrealMenuBar*fontList     : -*-helvetica-bold-r-*--14-*", 
           "*foreground                : black",
           "*background                : gray",
           "*fontList                  : -*-helvetica-medium-r-*--12-*",
           NULL
         };

  static char DrealTopLevelTitle[ 128 ] = "Dreal : ";

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    DrealChangeTopLevelTitle                 |
|                                                             |
\------------------------------------------------------------*/

void DrealChangeTopLevelTitle( Title )

  char *Title;
{
  rdsbegin();

  if ( Title != (char *)NULL )
  {
    strcpy( DrealTopLevelTitle + 8, Title  );
  }
  else
  {
    DrealTopLevelTitle[ 8 ] = '\0';
  }

  XtVaSetValues( DrealTopLevel, XmNtitle, DrealTopLevelTitle, NULL );

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                   DrealInitializeRessources                 |
|                                                             |
\------------------------------------------------------------*/

void DrealInitializeRessources( argc, argv )

     int  *argc;
     char *argv[];
{
  Arg Args[ 2 ];

  rdsbegin();

  DrealTopLevel = XtVaAppInitialize(
                                     &DrealApplication,
                                     "dreal.xrdb",
                                     NULL,
                                     0,
                                     argc,
                                     argv,
                                     DrealFallBacks,
                                     NULL 
                                   );

  DrealLoadTopLevelConfig();

  DrealInitializeColorMap();

  DrealMainWindow = XtVaCreateManagedWidget( "DrealMainWindow",
                                             xmMainWindowWidgetClass,
                                             DrealTopLevel,
                                             NULL);

  DrealMainForm = XtVaCreateManagedWidget( "DrealMainForm",
                                           xmFormWidgetClass,
                                           DrealMainWindow,
                                           XmNfractionBase,
                                           200,
                                           NULL );

  DrealInitializeIcon();
  DrealInitializeMenu();
  DrealInitializeMessage();
  DrealInitializePanel(); 
  DrealInitializeGraphic();
  DrealInitializeEvent();
  DrealBuildPanelMap();
  DrealInitializeMapEvent();
  DrealInitializeColors();
  DrealInitializeGraphicContext();
  DrealInitializeDialog();
  DrealBuildPanelLibrary();

  XtSetArg( Args[0], XmNallowShellResize, True ); 
  XtSetArg( Args[1], XmNdeleteResponse, XmDO_NOTHING );
  
  XtSetValues( DrealTopLevel, Args, 1 );
 
  XtRealizeWidget( DrealTopLevel );

  rdsend();
}
