/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                   Panel.c                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/PushB.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
 
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include GSB_H
# include GTB_H
# include GMF_H
# include GME_H
# include GMC_H
# include GMV_H
# include GMT_H
# include GMS_H
# include GMH_H
# include GMX_H

# include "GMX_panel.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    DrealInitializePanel                     |
|                                                             |
\------------------------------------------------------------*/

void DrealInitializePanel()

{
  rdsbegin();

  DrealBuildPanelLayer();
  DrealBuildPanelModify();
  DrealBuildPanelCreate();

  DrealBuildPanel( DrealMainWindow, &DrealToolsMessagePanel     );

  DrealBuildPanel( DrealMainWindow, &DrealViewArrowsPanel       );
  DrealBuildPanel( DrealMainWindow, &DrealViewZoomPanel         );
  DrealBuildPanel( DrealMainWindow, &DrealViewLayerPanel        );
  DrealBuildPanel( DrealMainWindow, &DrealViewGridPanel         );

  DrealBuildPanel( DrealMainWindow, &DrealCreateRectanglePanel );

  DrealBuildPanel( DrealMainWindow, &DrealEditGlobalPanel        );
  DrealBuildPanel( DrealMainWindow, &DrealWindowGlobalPanel      );
  DrealBuildPanel( DrealMainWindow, &DrealEditSelectPanel        );
  DrealBuildPanel( DrealMainWindow, &DrealEditSearchPanel        );
  DrealBuildPanel( DrealMainWindow, &DrealEditSearchViewPanel    );
  DrealBuildPanel( DrealMainWindow, &DrealEditIdentifyPanel      );

  DrealBuildPanel( DrealMainWindow, &DrealModifyRectanglePanel   );

  DrealBuildPanel( DrealMainWindow, &DrealSetupInformationsPanel );

  DrealBuildPresentPanel();

  rdsend();
}
