/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : SAX                                                         */
/*    Fichier : ConvMacro (Macro for double/int conversion)                 */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Michel DELVAL                         le : 12/05/1992     */
/*                                                                          */
/*    Modifie par : Vincent POUILLEY                    le : 20/09/1992     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/*    $Id: ConvMacro.h,v 1.1.1.1 1998/10/02 15:25:01 alliance Exp $              */
/*                                                                          */
/****************************************************************************/

#ifndef _ConvMacro_h_
#define _ConvMacro_h_


/* #define ROUND(n)						((int) ((n) + 0.5)) */

#ifndef ____SAX_PV_ROUND_VARIABLE____
#define ____SAX_PV_ROUND_VARIABLE____
double __SAX_PV_ROUND_VARIABLE__;
#endif

#define ROUND(n) (((__SAX_PV_ROUND_VARIABLE__ = (n)) < 0.) ? \
				  ((int)(__SAX_PV_ROUND_VARIABLE__ - 0.49)) : \
				  ((int)(__SAX_PV_ROUND_VARIABLE__ + 0.49)))

#define SCALE_TO_DOUBLE(scale,number)	((scale) * ((double) (number)))
#define SCALE_TO_INT(scale,number)		ROUND (SCALE_TO_DOUBLE ((scale), (number)))

#define UNSCALE_TO_DOUBLE(scale,number)	(((double) (number)) / (scale))
#define UNSCALE_TO_INT(scale,number)	ROUND (UNSCALE_TO_DOUBLE ((scale), (number)))

#endif /* _ConvMacro_h_ */
