/*************************************************************
*                  SOURCES                                   *
*                                                            *
* Changed by:    Greg                                        *
* Date:          05/07/95                                    *
* New file:      -                                           *
* Comments:                                                  *
*   Fonctions permettant d'ajouter un nouveau reseau dans    *
*   la figure logique existante.                             *
*                                                            *
*                                                            *
*************************************************************/

# include MUT_H
# include RDS_H
# include MLO_H
# include RCN_H
# include MPH_H
# include RPR_H
# include "extract.h"
# include "lynxrcn.h"
# include <stdio.h>
# include <stdlib.h>
# include <sys/timeb.h>
# include "addlynxrcn.h"
# include "Windows95.h"
# include "inter.h"
# include "mbkrds.h"
# include "chklynxrcn.h"
# include "buildrcn.h"
# include "via.h"

# include <math.h>

/*************************************************************
* La variable rcnlynxdebug doit etre fixee a 0 pour NE PAS   *
* avoir d'affichage sur la sortie STDERR.                    *
*                                                            *
*                                                            *
*************************************************************/

short rcnlynxdebug=0;
short rcnlynxchk=0;

long GrgNodeINDEX=1L;

/*************************************************************
*                                                            *
* Fonctions utilisees en interne par le programme.           *
*                                                            *
*                                                            *
*************************************************************/

void GrgConPh2ConLo __P((locon_list*, long));
void GrgDualConLoPh __P((lofig_list*));
void GrgGroupVia __P((lofig_list*));

/*************************************************************
* SOURCES                                                    *
*                                                            *
*                                                            *
*                                                            *
*************************************************************/

void generate_RCN(fig)
lofig_list *fig;

/*************************************************************

En entree, les rds doivent avoir dans leur champ user une ptype
normalement constituee. Les connecteurs logiques DOIVENT etre
relies aux connecteurs physiques grace a une liste chainee
accessible par un ptype du champ USER des locons. Les valeurs
que doit prendre l'identificateur de la ptype est definie
dans le fichier 'lynxrcn.h'.
A un connecteur physique, il n'y aura qu'un seul connecteur
logique attache, tandis qu'a un connecteur logique, il peut y
avoir plusieurs connecteurs physiques (ex des instances).
Pour les transistors, il n'y a qu'un connecteur physique par
connecteur logique.

*************************************************************/

{
  losig_list    *ScanSignal;    

  fflush(stdout);
  fflush(stderr);
  
  if(rcnlynxdebug)
  {
    fflush(stderr);
    fprintf(stderr,"\n\n--------- DEBUT DE LA FONCTION generate_RCN -----------\n");
    fflush(stderr);
  }

  printf("\t---> Net extract is running...\n"); fflush(stdout);

  if(rcnlynxdebug)
  {
    fprintf(stderr,"Figure d'entree\n");
    Grgdisplay_datain(fig);
    fprintf(stderr,"____________________________________________\n");
    fflush(stderr);
  }

  if(rcnlynxchk)
  {
    if(rcnlynxdebug)
      fprintf(stderr,
	      "Verification de la conformite des structures d'entree...\n");
    GrgChkInConFEqui(fig);
  }

  /*
  Ajoute pour chaque rectangle representant un connecteur un pointeur vers
  le connecteur logique correspondant. Ce pointeur est accessible par
  la valeur RDSLOCON
  */

  GrgDualConLoPh(fig);

  /*
  Permet de retrouver a partir d'un rectangle constituant un via les deux
  autres rectangles constituant ce via. Le pointeur est accessible par la
  valeur GRGVIA
  */
  GrgGroupVia(fig);

  if(rcnlynxchk)
  {
    if(rcnlynxdebug)
      fprintf(stderr,"Verification de la conformite des structures de travail...\n");
    GrgChkOutConVia(fig,rcnlynxdebug);
  }
  
  if(rcnlynxdebug)
  {
    fprintf(stderr,"Figure apres liaisons connecteur physique-logique\n");
    Grgdisplay_datain(fig);
    fprintf(stderr,"____________________________________________\n");
    fflush(stderr);
  }

  for(ScanSignal=fig->LOSIG; ScanSignal; ScanSignal=ScanSignal->NEXT)
  {
    /* Remise a un du compteur de noeud pour chaque Signal */

    GrgNodeINDEX=1L;

    buildrcn(fig,ScanSignal);

/*
    if(rcnlynxchk)
    {
      if(!rcn_check(getlorcnet(ScanSignal),0))
        printf("RCN error on signal %ld.\n",ScanSignal->INDEX);
    }
*/
  }


  if(rcnlynxdebug)
  {
    fprintf(stderr,"-------- SORTIE DE LA FONCTION generate_RCN -----------\n");
  }

  fflush(stderr);
  fflush(stdout);

}

void GrgDualConLoPh(fig)
lofig_list      *fig;
/*************************************************************
* Creer la relation connecteur physique vers connecteur      *
* logique a partir de la relation connecteur logique vers    *
* connecteur logique existante.                              *
*                                                            *
*************************************************************/
{
  loins_list    *ScanLoIns;     /* Pour parcourir les instances logiques                */
  lotrs_list    *ScanTrs;       /* Pour parcourir les transistors logiques              */

  if(rcnlynxdebug)
  {
    fprintf(stderr,"\nPlace dans le champ USER des rectangles connecteurs\n");
    fprintf(stderr,"le connecteur logique lui correspondant...\n");
  }

  if(rcnlynxdebug)
    fprintf(stderr,"  Traitement des connecteurs externes de la figure...\n");
  GrgConPh2ConLo(fig->LOCON,RDSLOCON1);
  
  if(rcnlynxdebug)
    fprintf(stderr,"  Traitement des connecteurs des instances...\n");
  for(ScanLoIns=fig->LOINS;ScanLoIns;ScanLoIns=ScanLoIns->NEXT)
  {
    GrgConPh2ConLo(ScanLoIns->LOCON,RDSLOCON2);
  }

  if(rcnlynxdebug)
    fprintf(stderr,"  Traitement des connecteurs des transistors...\n");
  for(ScanTrs=fig->LOTRS;ScanTrs;ScanTrs=ScanTrs->NEXT)
  {
    GrgConPh2ConLo(ScanTrs->DRAIN,RDSLOCON3);
    GrgConPh2ConLo(ScanTrs->GRID,RDSLOCON3);
    GrgConPh2ConLo(ScanTrs->SOURCE,RDSLOCON3);
    GrgConPh2ConLo(ScanTrs->BULK,RDSLOCON3);
  }
}





void GrgConPh2ConLo(connector,identificateur)
locon_list      *connector;     /*Structure classique des connecteurs chaines */
long             identificateur;

/*************************************************************
Cette fonction ajoute un ptype dans le champ USER des rectangles
connecteurs qui pointe sur le connecteur logique lui
correspondant. Les parametres de cette fonction sont:
-Une locon_list des connecteurs possedant un ptype repere par
 'identificateur' pointant sur une liste chainee contenant les
 adresses des rdsrec_list connecteur.
-Un identificateur defini dans 'lynxrcn.h'
*************************************************************/

{
  locon_list *ScanLoCon;
  chain_list *ScanChain;        /* liste chainee des rectangles connecteur */
  rdsrec_list *Rec_a;
  ptype_list  *ptl;

  for(ScanLoCon=connector;ScanLoCon;ScanLoCon=ScanLoCon->NEXT)
  {
    ptl = getptype( ScanLoCon->USER, identificateur );
    if( !ptl )
      continue;
    for(ScanChain=((chain_list*)(ptl->DATA));
	ScanChain;
	ScanChain=ScanChain->NEXT)
    {
      Rec_a=((rdsrec_list*)(ScanChain->DATA));
      ptl = getptype( Rec_a->USER, RDSLOCON );
      if( ptl )
        printf( "***LYNX RCN : ptype RDSLOCON found on rectangle.\n" );

      Rec_a->USER=addptype(Rec_a->USER,RDSLOCON,ScanLoCon);
    }
  }
}



void GrgFatalError(code)
int code;
{
  fprintf(stderr,"\n\n********************************************\n");
  fprintf(stderr,"*                                          *\n");
  fprintf(stderr,"*    ERREUR DANS LES STRUCTURES DE DONNEE  *\n");
  fprintf(stderr,"*                                          *\n");
  fprintf(stderr,"********************************************\n\n");

  fprintf(stderr,"Code d'erreur: %d\n",code);
  exit(code);
}



int IsRdsRealVia(r)
rdsrec_list *r;
{
  
  if(IsRdsVia(r))
  {
    if(GetLynxAttribute(r)!= C_X_N && GetLynxAttribute(r)!=C_X_P)
      return(1);
  } 
  return(0);
}

void GrgGroupVia(fig)
lofig_list      *fig;
/*************************************************************
* Ajoute un ptype dans le champ user des vias permettant de  *
* retrouver instantanement les deux autres couches du via.   *
*                                                            *
*                                                            *
*************************************************************/
{
  chain_list    *Vias=NULL;     /* Contient la chaine des vias de la figure (+rapide)   */
  chain_list    *FirstVias;     /* Pour effacer la liste chainee des Vias               */
  losig_list    *ScanLoSig;     /* Pour parcourir la liste des equipotentielles         */
  rdsrec_list   *ScanPhRec;     /* Pour la meme chose                                   */
  long           CX1,CY1;       /* Evite de recalculer le centre de chaque via          */
  long           CX2,CY2;       /* Evite de recalculer le centre de chaque via          */
  char           EndEqui;       /* Indique la fin du traitement de l'equi               */

  chain_list    *HeadGrpVia;	/* Tete de liste des nouveau GrgPhVia_list */
  chain_list    *ScanGrpVia;	/* Pour pacourir cette liste */
  rdsrec_list   *Rec;		/* Contient le rectangle du via */
  GrgPhVia_list *NewGrpVia;	/* Nouvel element */
  ptype_list	*ptl;
  int            nouv;          /* Il faut creer un nouveau GrgVia                      */

  /* Donnees sur le fenetrage */
  long           mx=0,MX=0,my=0,MY=0;   /* Contient la taille mini/maxi du circuit */
  long           nbvia;         /* Contient le nombre de via du signal */
  long           WinSizeX,WinSizeY;	/* Taille des fenetres */
  long           WinNbX,WinNbY;		/* Nombre de fenetre */
  unsigned       N;		/* Nombre de fenetre sur 1 cote */
  chain_list   **WinVia;	/* Tete de liste chainee des Via element de la fenetre */
  long           WinX,WinY;	/* Emplacement de la fenetre */
  long           i;		
  chain_list    *scanchain;
  int            l,l1,l2,l3;
  GrgPhVia_list *gv1,*gv2;
  chain_list    *Scgv1,*Scgv2;
  num_list      *REV_RDS_VIA_TABLE[LAST_LAYER]; /* Donne pour un layer les vias possibles */
  num_list      *scanprev;
  int            Layer;
  int            a,b;
  int            mxvia;
  rdsrec_list   *via[4];
  
  
/*************************************************************
* Principe: creer une liste chainee des nouvelles structures *
* crees, puis supprime le chainage a la fin.                 *
*                                                            *
*                                                            *
*************************************************************/

  if(rcnlynxdebug)
    fprintf(stderr,"  Traitement des vias...\n");

  for( l1 = 0 ; l1 < LAST_LAYER ; l1++ )
      REV_RDS_VIA_TABLE[l1] = NULL;
 
  for( l1 = 0 ; l1 < MBK_MAX_VIA ; l1++ )
    for( l2 = 0 ; GET_VIA_LAYER(l1,l2) != RDS_VIA_EMPTY; l2++ )
      REV_RDS_VIA_TABLE[ GET_VIA_LAYER(l1,l2 ) ] = addnum ( REV_RDS_VIA_TABLE[ GET_VIA_LAYER(l1,l2 ) ], l1 );

  for(ScanLoSig=fig->LOSIG; ScanLoSig; ScanLoSig=ScanLoSig->NEXT)
  {

    /* Cree une liste chainee des vias de l'equipotentielle traitee */

    Vias=NULL;
    nbvia=0L;

    for( scanchain = (chain_list*)(getptype(ScanLoSig->USER,RCN_FEQUI)->DATA) ;
         scanchain ;
         scanchain = scanchain->NEXT
       )
    {
      ScanPhRec = (rdsrec_list*)(scanchain->DATA); 
      EndEqui   = 0 ;
      while(!EndEqui)
      {
        if(IsRdsRealVia(ScanPhRec))
        {
          Vias=addchain(Vias,ScanPhRec);
          
          nbvia++;
          CX1= ScanPhRec->X + ((ScanPhRec->DX)>>1);
          CY1= ScanPhRec->Y + ((ScanPhRec->DY)>>1);
        
          if(nbvia>1)
          { 
            if(ScanPhRec->X<mx) mx=ScanPhRec->X;
            if(ScanPhRec->Y<my) my=ScanPhRec->Y;
            if(ScanPhRec->X+ScanPhRec->DX>MX) MX=ScanPhRec->X+ScanPhRec->DX;
            if(ScanPhRec->Y+ScanPhRec->DY>MY) MY=ScanPhRec->Y+ScanPhRec->DY;
          }
          else
          {
            mx=MX=CX1;
            my=MY=CY1;
          }
        }
        if(IsLynxEndEqui(ScanPhRec))
    	  EndEqui=1;
        else
  	  ScanPhRec=LYNX_EQUI(ScanPhRec);
      }
    }
    /* Traite les vias de l'equi */
    if(nbvia)
    {
      FirstVias=Vias;

      /* Creation du fenetrage du chip */
      N=(unsigned)(sqrt((double)nbvia));
      WinSizeX=(MX-mx)/N;
      WinSizeY=(MY-my)/N;
      
      if( WinSizeX == 0 )
        WinSizeX = 1;
      
      if( WinSizeY == 0 )
        WinSizeY = 1;

      WinNbX=(MX-mx)/WinSizeX+1;
      WinNbY=(MY-my)/WinSizeY+1;
  
      WinVia=(chain_list**)mbkalloc(sizeof(chain_list)*WinNbX*WinNbY);
      for(i=0;i<WinNbX*WinNbY;i++)
        WinVia[i]=NULL;

      /* Place les vias dans la bonne fenetre */
      for(Vias=FirstVias; Vias; Vias=Vias->NEXT)
      {
        CX1=((rdsrec_list*)(Vias->DATA))->X +
            (((rdsrec_list*)(Vias->DATA))->DX>>1);
        CY1=((rdsrec_list*)(Vias->DATA))->Y +
            (((rdsrec_list*)(Vias->DATA))->DY>>1);
    
        WinX=(CX1-mx)/WinSizeX;
        WinY=(CY1-my)/WinSizeY;

        WinVia[WinX+WinY*WinNbX]=addchain(WinVia[WinX+WinY*WinNbX],Vias->DATA);
      }

      freechain(FirstVias);

      /* Parcours la liste de chaque fenetre et regroupe les vias au
       sein de chacune d'elle */

      for(i=0;i<WinNbX*WinNbY;i++)
      {
        HeadGrpVia=NULL;
        for(Vias=WinVia[i];Vias;Vias=Vias->NEXT)
        {
          Rec=(rdsrec_list*)(Vias->DATA);
          Layer = GetRdsLayer( Rec );
          CX1=Rec->X + ( Rec->DX>>1 );
          CY1=Rec->Y + ( Rec->DY>>1 );

          nouv = 1;
         
          for( ScanGrpVia = HeadGrpVia ; ScanGrpVia && nouv ; ScanGrpVia = ScanGrpVia->NEXT )
          {
            NewGrpVia=(GrgPhVia_list*)(ScanGrpVia->DATA);
            CX2=NewGrpVia->X;
            CY2=NewGrpVia->Y;
        
            if(CX1==CX2 && CY1==CY2)
            {
              /* On recherche si cette structure est compatible avec le via */
              /* Premier critere : un niveau ne doit apparaitre qu'une seule fois dans le via */
              if( Layer == GetRdsLayer( NewGrpVia->LAYER1 ) )
                continue;
              if( NewGrpVia->LAYER2 )
                if( Layer == GetRdsLayer( NewGrpVia->LAYER2 ) )
                  continue;
              if( NewGrpVia->LAYER3 )
                if( Layer == GetRdsLayer( NewGrpVia->LAYER3 ) )
                  continue;

              /* Deuxieme crite : Le via teste doit contenir tous les layer du grpvia, et celui du Rec */
              mxvia = 0;
              if( NewGrpVia->LAYER1 )
                via[mxvia++] = NewGrpVia->LAYER1 ;
              if( NewGrpVia->LAYER2 )
                via[mxvia++] = NewGrpVia->LAYER2 ;
              if( NewGrpVia->LAYER3 )
                via[mxvia++] = NewGrpVia->LAYER3 ;
              via[mxvia++] = Rec ;

              for( scanprev = REV_RDS_VIA_TABLE[ GetRdsLayer(Rec) ] ; scanprev ; scanprev = scanprev->NEXT )
              {
                for( b = 0 ; b<mxvia ; b++ )
                {
                  for( a=0 ; GET_VIA_LAYER( scanprev->DATA , a ) != RDS_VIA_EMPTY ; a++ )
                    if( GET_VIA_LAYER( scanprev->DATA, a ) == GetRdsLayer( via[b] ) )
                      break;
                  if( GET_VIA_LAYER( scanprev->DATA , a ) == RDS_VIA_EMPTY )
                    break;
                }
                if( b==mxvia )
                  break;
              }

              if( scanprev )
              {
                nouv = 0;
                if( !NewGrpVia->LAYER2 ) 
                  NewGrpVia->LAYER2 = Rec ;
                else
                {
                  NewGrpVia->LAYER3 = Rec ;
                  /* On reordonne du layer le plus bas vers le layer le plus haut */
                  l1 = GetRdsLayer( NewGrpVia->LAYER1 );
                  l2 = GetRdsLayer( NewGrpVia->LAYER2 );
                  l3 = GetRdsLayer( NewGrpVia->LAYER3 );
                  l = min( l1, min( l2, l3 ) );
                  if( l == l2 )
                  {
                    Rec = NewGrpVia->LAYER1 ;
                    NewGrpVia->LAYER1 = NewGrpVia->LAYER2 ;
                    NewGrpVia->LAYER2 = Rec ; 
                  }
                  else
                  if( l == l3 )
                  {
                    Rec = NewGrpVia->LAYER1 ;
                    NewGrpVia->LAYER1 = NewGrpVia->LAYER3 ;
                    NewGrpVia->LAYER3 = Rec ;
                  }
                  l2 = GetRdsLayer( NewGrpVia->LAYER2 );
                  l3 = GetRdsLayer( NewGrpVia->LAYER3 );
                  if( l2 > l3 )
                  {
                    Rec = NewGrpVia->LAYER2 ;
                    NewGrpVia->LAYER2 = NewGrpVia->LAYER3 ;
                    NewGrpVia->LAYER3 = Rec ;
                  }
                }
              }
            }
          }

          if( nouv == 1 )
          {
            NewGrpVia=(GrgPhVia_list*)mbkalloc(sizeof(GrgPhVia_list));
            NewGrpVia->LAYER1=Rec;
            NewGrpVia->LAYER2=NULL;
            NewGrpVia->LAYER3=NULL; 
            NewGrpVia->X=CX1;
            NewGrpVia->Y=CY1;
            HeadGrpVia=addchain(HeadGrpVia,NewGrpVia);
          }
        }
        freechain(WinVia[i]);

        /* On vire tous les vias en double et on cree les ptypes dans les rectangles */
        /* !! Algo en n2 sur chaque fenetre */

        if( HeadGrpVia )
        {
          for( Scgv1 = HeadGrpVia ; Scgv1->NEXT ; Scgv1 = Scgv1->NEXT )
          {
            gv1 = ((GrgPhVia_list*)(Scgv1->DATA));          
            
            if( !gv1 )
              continue;

            for( Scgv2 = Scgv1->NEXT ; Scgv2 ; Scgv2 = Scgv2->NEXT )
            {
              gv2 = ((GrgPhVia_list*)(Scgv2->DATA));
              if( !gv2 )
                continue;
              
              if( gv1->X == gv2->X && gv1->Y == gv2->Y )
              {
                if( GetRdsLayer( gv1->LAYER1 ) == GetRdsLayer( gv2->LAYER1 ) &&
                    GetRdsLayer( gv1->LAYER2 ) == GetRdsLayer( gv2->LAYER2 ) &&
                    GetRdsLayer( gv1->LAYER3 ) == GetRdsLayer( gv2->LAYER3 )   )
                {
                  mbkfree( gv2 );
                  Scgv2->DATA = NULL;
                }
              }
            }
          }
  
          for( Scgv1 = HeadGrpVia ; Scgv1 ; Scgv1 = Scgv1->NEXT )
          {
            gv1 = ((GrgPhVia_list*)(Scgv1->DATA));

            if( !gv1 )
              continue;

            ptl = getptype( ScanLoSig->USER, GRGVIA );
              
            if( ptl )
            {
              gv1->NEXT=ptl->DATA;
              ptl->DATA=gv1;
            }
            else
            {
              gv1->NEXT=NULL;
              ScanLoSig->USER=addptype(  ScanLoSig->USER,
                                         GRGVIA,
                                         gv1
                                      );
            }
          }
           
          freechain(HeadGrpVia);
        }
      }
      mbkfree(WinVia);
    }
  }
  if(rcnlynxdebug)
    fprintf(stderr,"Fin du traitement des vias\n");
}
