/*------------------------------------------------------------\
|                                                             |
| Tool    :                   LYNX                            |
|                                                             |
| File    :                  bulk.c                           |
|                                                             |
| Author  :              Picault Stephane         *4p*        |
|                                                             |
| Date    :                  15.07.98                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>

# include MUT_H
# include MLO_H
# include MPH_H
# include RDS_H
# include RWI_H
# include RUT_H
# include RPR_H
# include RFM_H

# include "mbkrds.h"
# include "box.h"
# include "bulk.h"
# include "error.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       LynxAddLayerImplicit                  |
|                                                             |
\------------------------------------------------------------*/

void LynxAddLayerImplicit( Figure, Window )

  rdsfig_list *Figure;
  rdswindow   *Window;
{
   long          Layer;
   rdsrec_list  *Rec;

   for ( Layer = 0; Layer < RDS_MAX_LAYER; Layer++ )
   {
      if ( GET_LYNX_BULK_IMPLICIT ( Layer ) != RDS_LYNX_BULK_IMPLICIT_EMPTY )
      {
            Rec = addrdsfigrec( Figure,
                                        "implicit",
                                        Layer,
                                        Window->XMIN,
                                        Window->YMIN,
                                        Window->XMAX,
                                        Window->YMAX );

            SetLynxTreat( Rec );
            LYNX_LINK( Rec ) = Rec;
            addrdsrecwindow( Rec, Window );
      }
   }
}
