/*------------------------------------------------------------\
|                                                             |
| Tool    :                   LYNX                            |
|                                                             |
| File    :                  lyerror.h                        |
|                                                             |
| Authors :               Jacomme Ludovic                     |
|                                                             |
| Date    :                  01.08.93                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef LYNX_ERROR
# define LYNX_ERROR

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                             Error                           |
|                                                             |
\------------------------------------------------------------*/

# define LYNX_ERROR_PHYSICAL_CONNECTOR            0
# define LYNX_ERROR_PHYSICAL_CONNECTORS           1
# define LYNX_ERROR_MISSING_CONNECTOR             2
# define LYNX_ERROR_CUT_TRANSISTOR_ELBOW          3
# define LYNX_ERROR_MASK_COUNTER_NULL             4
# define LYNX_ERROR_ILLEGAL_COMBINATION           5
# define LYNX_ERROR_ILLEGAL_OPTION                6
# define LYNX_ERROR_ILLEGAL_FILENAME              7
# define LYNX_ERROR_MINIMUM_LENGTH                8
# define LYNX_ERROR_TRANSISTOR_GATE               9
# define LYNX_ERROR_TRANSISTOR_LOGICAL           10

/*------------------------------------------------------------\
|                                                             |
|                             Warning                         |
|                                                             |
\------------------------------------------------------------*/

# define LYNX_WARNING_PHYSICAL_CONNECTOR          0
# define LYNX_WARNING_CORE_FILE                   1

/*------------------------------------------------------------\
|                                                             |
|                             Macros                          |
|                                                             |
\------------------------------------------------------------*/

# define LynxError( E, T1, T2 )(lynx_error( (E), (T1), (T2), __FILE__, __LINE__ ))
# define LynxWarning( W, T ) (lynx_warning( (W), (T), __FILE__, __LINE__ ))

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void lynx_error();
  extern void lynx_warning();

# endif
