/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef rfg_head_h
#define rfg_head_h

/*******************************************************************/
/*******************************************************************/
/**                                                               **/
/**  RFG_HEAD                                                     **/
/**                                                               **/
/**  Version 6.03                                                 **/
/**                                                               **/
/*******************************************************************/
/*******************************************************************/

static char *ident_head="@(#)(RFG) header, version 6.03 (03/12/1993)";

/*******************************************************************/

/* if rfg_crunch_name if defined : 7 characters block name are generated, */
/* else long block name are generated. */

/*
#define rfg_crunch_name
*/

/*******************************************************************/

/* if rfg_alims_vbe is defined : alims appears in interface, */
/* else no alims are declare. */

#define rfg_alims_vbe

/*******************************************************************/

/* if rfg_convert is defined : convert function is explicitly */
/* call, else all conversion are implicit. */

/*
#define rfg_convert
*/

/*******************************************************************/

/*                ___          */
/* CK_S       ___|   |________ */
/*                        ___  */
/* CK_M       ___________|   | */
/*                             */
/* phase name  S0  S1  M0  M1  */

/* if rfg_quad is defined : 4 phases by cycle for simulation (S0, S1, M0 and M1) */
/* else 2 phases by cycle (S1 and M1). */

/*
#define rfg_quad
*/

#ifdef  rfg_quad
#define rfg_phase_s0 /* add a S0 phase */
#define rfg_phase_m0 /* add a M0 phase */
#else
/*
#define rfg_phase_s0
*/
#define rfg_phase_m0
#endif

/*******************************************************************/

#ifdef rfg_crunch_name
#define rfg_pref_length 9 /* Max size of files's prefix. */
#endif

/*******************************************************************/

#ifdef Wall
int fprintf();
int getpid();
int printf();
int fclose();
int sscanf();
#endif

/*******************************************************************/

#define rfg_WIDTH_MIN   2L
#define rfg_WIDTH_MAX   256L
#define rfg_HIGH_MIN    2L
#define rfg_HIGH_MAX    64L

#define rfg_reg_only    0L
#define rfg_reg_sep     1L
#define rfg_dec_sep     2L
#define rfg_bank        3L

/*******************************************************************/

#endif
