/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                   abldel.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "abldel.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Del  Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Del Abl Expr                        |
|                                                             |
\------------------------------------------------------------*/

void delablexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ScanExpr;

  if ( ABL_ATOM( Expr ) )
  {
    freechain( Expr );
  }
  else
  {
    ScanExpr = Expr;

    freechain( ABL_CAR( Expr ) );

    while ( ( ScanExpr = ABL_CDR( ScanExpr ) ) != (ablexpr *)0 )
    {
      delablexpr( ABL_CAR( ScanExpr ) );
    }

    freechain( Expr );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                         Del Abl Expr Number                 |
|                                                             |
\------------------------------------------------------------*/

void delablexprnum( Expr, Number )

  ablexpr *Expr;
  int         Number;
{
  ablexpr *PrevExpr;
  int         Counter;

  if ( ! ABL_ATOM( Expr ) )
  {
    PrevExpr = Expr;
    Counter  = 0;

    while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
    {
      if ( Counter == Number )
      {
        ABL_CDR( PrevExpr ) = ABL_CDR( Expr );
        ABL_CDR( Expr     ) = (ablexpr *)0;

        delablexpr( ABL_CAR( Expr ) );
        freechain( Expr );

        return;
      }
      
      Counter  = Counter + 1;
      PrevExpr = Expr;
    }
  }
}
