/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                   abldev.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "abldev.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Develop Functions                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                 Develop Duplicate Abl Xor Expr              |
|                                                             |
\------------------------------------------------------------*/

ablexpr *devdupablxorexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ExprDev;
  ablexpr *ExprQueue;
  long        Oper;

  if ( ABL_ATOM( Expr ) )
  {
    return( addchain( (ablexpr *)0, ABL_CAR( Expr ) ) );
  }

  Oper = ABL_OPER( Expr );

  if ( ( Oper == ABL_XOR  ) ||
       ( Oper == ABL_NXOR ) )
  {
    Expr    = ABL_CDR( Expr );
    ExprDev = dupablexpr( ABL_CAR( Expr ) );

    while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
    {
      ExprDev = optimablxorbinexpr( Oper, 
                                    ExprDev,
                                    devdupablxorexpr( ABL_CAR( Expr ) ) );
    }
  }
  else
  {
    ExprDev = addchain( (ablexpr *)0,
                        (void *)addchain( (ablexpr *)0,
                                          (void *)Oper ) );
    ExprQueue = ExprDev;

    while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
    {
      ABL_CDR( ExprQueue ) = addchain( (ablexpr *)0,
                                       (void *)devdupablxorexpr( ABL_CAR( Expr ) ) );
      ExprQueue = ABL_CDR( ExprQueue );
    }
  }

  return( ExprDev );
}

/*------------------------------------------------------------\
|                                                             |
|                      Develop Abl Xor Expr                   |
|                                                             |
\------------------------------------------------------------*/

ablexpr *devablxorexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ExprDev;
  ablexpr *ScanExpr;
  long        Oper;

  if ( ABL_ATOM( Expr ) )
  {
    return( Expr );
  }

  Oper = ABL_OPER( Expr );

  if ( ( Oper == ABL_XOR  ) ||
       ( Oper == ABL_NXOR ) )
  {
    ScanExpr = ABL_CDR( Expr );
    ExprDev  = ABL_CAR( ScanExpr );

    while ( ( ScanExpr = ABL_CDR( ScanExpr ) ) != (ablexpr *)0 )
    {
      ExprDev = optimablxorbinexpr( Oper, 
                                    ExprDev,
                                    devablxorexpr( ABL_CAR( ScanExpr ) ) );
    }

    freechain( Expr );
  }
  else
  {
    ExprDev = Expr;

    while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
    {
      ABL_CAR( Expr ) = (void *)devablxorexpr( ABL_CAR( Expr ) );
    }
  }

  return( ExprDev );
}
