/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                   ablmap.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "ablmap.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Map  Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Map Abl Expression                     |
|                                                             |
\------------------------------------------------------------*/

void mapablexpr( Function, Expr )

  void      (*Function)();
  ablexpr *Expr;
{
  while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
  {
    (*Function)( ABL_CAR( Expr ) );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                      Map Abl Sub Expression                 |
|                                                             |
\------------------------------------------------------------*/

ablexpr *mapabloperexpr( Function, Oper, Expr )

  ablexpr *(*Function)();
  long        Oper;
  ablexpr *Expr;
{
  ablexpr *MapExpr;

  MapExpr = createabloper( Oper );

  while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
  {
    addablhexpr( MapExpr, (*Function)( ABL_CAR( Expr ) ) );
  }

  return( MapExpr );
}

/*------------------------------------------------------------\
|                                                             |
|                      Map Abl Any Expression                 |
|                                                             |
\------------------------------------------------------------*/

int mapablanyexpr( Function, Expr )

  int       (*Function)();
  ablexpr *Expr;
{
  while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
  {
    if ( (*Function)( ABL_CAR( Expr ) ) ) return( 1 );
  }

  return( 0 );
}

/*------------------------------------------------------------\
|                                                             |
|                      Map Abl Every Expression               |
|                                                             |
\------------------------------------------------------------*/

int mapableveryexpr( Function, Expr )

  int       (*Function)();
  ablexpr *Expr;
{
  while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
  {
    if ( ! (*Function)( ABL_CAR( Expr ) ) ) return( 0 );
  }

  return( 1 );
}
