/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                  ablunflat.c                      |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "ablunflat.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Flat Abl Expr                       |
|                                                             |
\------------------------------------------------------------*/

ablexpr *unflatablexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ScanExpr;
  long        Oper;
  int         Binary;
  int         Polar;

  if ( ! ABL_ATOM( Expr ) )
  {
    Oper = ABL_OPER( Expr );

    Binary = isablbinaryoper( Oper );

    if ( Binary != 0 )
    {
      Polar = getabloperpolar( Oper );

      if ( ABL_CDR( ABL_CDDR( Expr ) ) != (ablexpr *)0 )
      {
        if ( Polar != ABL_POLAR_POSITIVE )
        {
          Oper = getablopernot( Oper );
          ABL_OPER( Expr ) = Oper;

          ScanExpr = createabloper( ABL_NOT );
          addablhexpr( ScanExpr, Expr );

          Expr = ScanExpr;
        }
        else
        {
          ScanExpr = createabloper( Oper );
          ABL_CDR( ScanExpr ) = ABL_CDDR( Expr );
          ABL_CDDR( Expr ) = addchain( (ablexpr *)0, (void *)ScanExpr );
        }
      }
    }

    ScanExpr = Expr;

    while ( ( ScanExpr = ABL_CDR( ScanExpr ) ) != (ablexpr *)0 )
    {
      ABL_CAR( ScanExpr ) = unflatablexpr( ABL_CAR( ScanExpr ) );
    }
  }

  return( Expr );
}
