# include <stdio.h>
# include <malloc.h>

# include MUT_H
# include AUT_H
# include ABL_H

static char Buffer[ 512 ];

ablexpr *bitstring2abl( Variable, Left, Right, BitString )

  char *Variable;
  int   Left;
  int   Right;
  char *BitString;
{
  ablexpr *Equation;
  ablexpr *Expr;
  int         Reverse;
  int         BitIndex;
  int         Index;

  if ( Left > Right )
  {
    Reverse  = Right;
    Right    = Left;
    Left     = Reverse;

    Reverse  = 1;
    BitIndex = Right - Left;
  }
  else
  {
    Reverse  = 0;
    BitIndex = 0;
  }

  Equation = createabloper( ABL_AND );

  for ( Index = Left; Index <= Right; Index++ )
  {
    sprintf( Buffer, "%s %d", Variable, Index );

    if ( BitString[ BitIndex ] == '0' )
    {
      addablhexpr( Equation, createablnotexpr( createablatom( Buffer ) ) );
    }
    else
    if ( BitString[ BitIndex ] == '1' )
    {
      addablhexpr( Equation, createablatom( Buffer ) );
    }
    else break;

    if ( Reverse ) BitIndex--;
    else           BitIndex++;
  }

  if ( ABL_CDR( Equation ) == (ablexpr *)0 )
  {
    delablexpr( Equation );
    Expr = createablatom( "'1'" );
  }
  else
  if ( ABL_CDDR( Equation ) == (ablexpr *)0 )
  {
    Expr = dupablexpr( ABL_CADR( Equation ) );
    delablexpr( Equation );
  }
  else
  {
    Expr = Equation;
  }

  return( Expr );
}

int main( argc, argv )

  int    argc;
  char **argv;
{
  ablexpr *Expr1;
  ablexpr *Expr2;

  mbkenv();
  autenv();
  ablenv();

  Expr1 = createablbinexpr( ABL_XOR,
                         createablatom( "'1'" ),
                         createablatom( "a" ) );
  Expr1 = simpablexpr( Expr1 );
  viewablexpr( Expr1, ABL_VIEW_VHDL );
 
  return( 0 );

/*\
  if ( argc < 5 )
  {
    fprintf( stdout, "%s Variable Left Right BitString\n", argv[0] );
  }
  else
  {
    Expr = bitstring2abl( argv[1], atoi( argv[2] ), atoi( argv[3] ), argv[4] );
    viewablexpr( Expr, ABL_VIEW_VHDL );
    fprintf( stdout, "\n" );
    delablexpr( Expr );
  }
\*/
}
