# include <stdio.h>
# include <malloc.h>

# include MUT_H
# include AUT_H
# include ABL_H
# include ABE_H
# include ABV_H


/*------------------------------------------------------------\
|                                                             |
|                            Usage                            |
|                                                             |
\------------------------------------------------------------*/

void BvlUsage()
{
  fprintf( stderr, "\t\tbvltest [Options] Input_name\n\n" );
  fprintf( stdout, "\t\tOptions : -V Sets Verbose mode on\n" );
  fprintf( stdout, "\n" );

  exit( 1 );
}

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

  int    argc;
  char **argv;
{
  befig_list *Figure;
  char       *InputFileName;
  int         Number;
  int         Index;
  char        Option;
  long        Value;

  int FlagVerbose = 0;

  mbkenv();
  autenv();
  ablenv();

  InputFileName = (char *)0;

  if ( argc < 2 ) BvlUsage();

  InputFileName = (char *)0;

  for ( Number = 1; Number  < argc; Number++ )
  {
    if ( argv[ Number ][ 0 ] == '-' )
    {
      for ( Index = 1; argv[ Number ][ Index ] != '\0'; Index++ )
      {
        Option = argv[ Number ][ Index ];

        switch ( Option )
        {
          case 'V' : FlagVerbose = 1;
          break;
          default  : BvlUsage();
        }
      }
    }
    else
    if ( InputFileName == (char *)0 ) InputFileName = argv[ Number ];
    else
    BvlUsage();
  }

  if ( InputFileName == (char *)0 ) BvlUsage();

  Figure = vhdlloadbefig( NULL, InputFileName, 0);

  beh_frebefig( Figure );
}
