/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                  autalloc.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H

# include <stdio.h>
# include <malloc.h>
# include <memory.h>
# include <string.h>
# include "autalloc.h"
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char  *AutHeapHeadArray[ 256 ];
  char   InitAutHeapHeadArray = 1;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Alloc Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Aut Alloc                          |
|                                                             |
\------------------------------------------------------------*/

char *autalloc( Size, Heap )

   unsigned int Size; 
   char         Heap;
{
  int           Counter;
  unsigned int  Index;
  int           HeapSize;
  char         *Pointer;
  char        **Prev;
  char         *Scan;

  if ( ( Heap != AUT_ALLOC_BLOCK ) &&
       ( Heap != AUT_ALLOC_HEAP  ) )
  {
    auterror( AUT_ALLOC_ERROR, (char *)0 );
  }

  if ( Size == 0 )
  {
    auterror( AUT_ALLOC_SIZE_ERROR, (char *)0 );
  }

  if ( InitAutHeapHeadArray == 1 )
  { 
    InitAutHeapHeadArray = 0;

    for ( Counter = 0; Counter < 256 ; Counter++ )
    {
      AutHeapHeadArray[ Counter ] = (char *)0;
    }
  }

  Index = ( Size + 3 ) >> 2;

  if ( ( Heap    == AUT_ALLOC_BLOCK ) ||
       ( Index   >  255             ) )
  {
    if ( ! ( Pointer = malloc( Size ) ) ) 
    {
      auterror( AUT_ALLOC_ERROR, (char *)0 );
    }

    memset( Pointer, 0, Size );
  
    return( Pointer );
  } 

  Size = Index << 2;

  if ( AutHeapHeadArray[ Index ] == (char *)0 )
  {
    HeapSize = ( Size << AUT_ALLOC_SHIFT );

    if ( ! ( Pointer = malloc( HeapSize ) ) ) 
    {
      auterror( AUT_ALLOC_ERROR, (char *)0 );
    }

    memset( Pointer, 0, HeapSize );

    Scan = (char *)(Pointer + Size);

    Prev = &AutHeapHeadArray[ Index ];

    for ( Counter = 1; Counter < AUT_ALLOC_SIZE; Counter++ )
    {
      *Prev = Scan; Prev = (char **)Scan; Scan = (char *)(Scan + Size);
    }

    *Prev = (char *)0;

    AutHeapHeadArray[ Index ] = (char *)(Pointer + Size);

    return( Pointer );
  }

  Pointer = AutHeapHeadArray[ Index ];

  AutHeapHeadArray[ Index ] = *((char **)AutHeapHeadArray[ Index ]);

  *(char **)(Pointer ) = (char *)0;

  return( Pointer );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Alloc Debug                      |
|                                                             |
\------------------------------------------------------------*/

autdebug_list *allocautdebug()
{
  return( (autdebug_list *)(autallocheap( sizeof( autdebug_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Alloc Hash Element               |
|                                                             |
\------------------------------------------------------------*/

authelem *allocauthelem( Number )

  unsigned int Number;
{
  return( (authelem  *)autallocblock( sizeof( authelem ) * Number ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Alloc Hash Table                 |
|                                                             |
\------------------------------------------------------------*/

authtable *allocauthtable()
{
  return( (authtable  *)autallocblock( sizeof( authtable ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Alloc Hash Element               |
|                                                             |
\------------------------------------------------------------*/

auth2elem *allocauth2elem( Number )

  unsigned int Number;
{
  return( (auth2elem  *)autallocblock( sizeof( auth2elem ) * Number ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Alloc Hash Table                 |
|                                                             |
\------------------------------------------------------------*/

auth2table *allocauth2table()
{
  return( (auth2table  *)autallocblock( sizeof( auth2table ) ) );
}
