/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                  autadebug.c                      |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :                Jacomme Ludovic                    |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H

# include <stdio.h>
# include <signal.h>
# include "autdebug.h"
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

 autdebug_list *HEAD_AUTDEBUG = (autdebug_list *)0;
 char           AUT_DEBUG_ON  = 0;

/*------------------------------------------------------------\
|                                                             |
|                          Privates                           |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          trapautdebug                       |
|                                                             |
\------------------------------------------------------------*/

void trapautdebug()
{
  autdebug_list *ScanDebug;

  for ( ScanDebug  = HEAD_AUTDEBUG;
        ScanDebug != (autdebug_list *)0;
        ScanDebug  = ScanDebug->NEXT )
  {
    fprintf( stdout, "autdebug: file %s line %d\n", 
             ScanDebug->NAME, ScanDebug->LINE );
  }

  signal( SIGQUIT, trapautdebug );
  signal( SIGSEGV, SIG_DFL      );
  signal( SIGBUS , SIG_DFL      );
  signal( SIGILL , SIG_DFL      );
}

/*------------------------------------------------------------\
|                                                             |
|                          autdebug                           |
|                                                             |
\------------------------------------------------------------*/

void autdebug()
{
  signal( SIGSEGV, trapautdebug );
  signal( SIGBUS,  trapautdebug );
  signal( SIGILL,  trapautdebug );
  signal( SIGQUIT, trapautdebug );

  AUT_DEBUG_ON = 1;
}

/*------------------------------------------------------------\
|                                                             |
|                          addautdebug                        |
|                                                             |
\------------------------------------------------------------*/

void addautdebug( Line, File )

  int   Line;
  char *File;
{
  autdebug_list *NewDebug;

  NewDebug       = allocautdebug();
  NewDebug->NEXT = HEAD_AUTDEBUG;
  NewDebug->LINE = Line;
  NewDebug->NAME = File;
  HEAD_AUTDEBUG  = NewDebug;
}

/*------------------------------------------------------------\
|                                                             |
|                          delautdebug                        |
|                                                             |
\------------------------------------------------------------*/

void delautdebug()
{
  autdebug_list *DelDebug;

  DelDebug = HEAD_AUTDEBUG;

  if ( DelDebug != (autdebug_list *)0 )
  {
    HEAD_AUTDEBUG = DelDebug->NEXT;
    freeautdebug( DelDebug );
  }
}
