/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                  autfree.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H

# include <stdio.h>
# include <malloc.h>
# include <memory.h>
# include <string.h>
# include "autfree.h"
# include "autalloc.h"
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     Aut Free Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Aut Free                           |
|                                                             |
\------------------------------------------------------------*/

void  autfree( Pointer, Size )

      char         *Pointer;
      unsigned int  Size;
{
  unsigned int Index;

  Index = ( Size + 3 ) >> 2;

  if ( ( Size  == 0              ) ||
       ( Index > 255             ) )
  {
    free( Pointer );
  }
  else
  {
    memset( Pointer, 0, Size );

    *((char **)Pointer) = AutHeapHeadArray[ Index ];

    AutHeapHeadArray[ Index ] = Pointer;
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Free Debug                       |
|                                                             |
\------------------------------------------------------------*/

void freeautdebug( Debug )

  autdebug_list *Debug;
{
  autfreeheap( (char *)Debug, sizeof( autdebug_list ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Free Hash Element                |
|                                                             |
\------------------------------------------------------------*/

void freeauthelem( Element )

  authelem *Element;
{
  autfreeblock( (char *)Element );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Free Hash Table                  |
|                                                             |
\------------------------------------------------------------*/

void freeauthtable( HashTable )

  authtable *HashTable;
{
  autfreeblock( (char *)HashTable );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Free Hash Element 2              |
|                                                             |
\------------------------------------------------------------*/

void freeauth2elem( Element )

  auth2elem *Element;
{
  autfreeblock( (char *)Element );
}

/*------------------------------------------------------------\
|                                                             |
|                        Aut Free Hash Table 2                |
|                                                             |
\------------------------------------------------------------*/

void freeauth2table( HashTable )

  auth2table *HashTable;
{
  autfreeblock( (char *)HashTable );
}
