/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                   autname.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H

# include <stdio.h>
# include <string.h>
# include "autname.h"
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static chain_list *AutNameHashTable[ AUT_NAME_HASH_SIZE ];
  static char        AutNameBuffer[ AUT_NAME_BUFFER_SIZE ]; 

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Aut Name Alloc                     |
|                                                             |
\------------------------------------------------------------*/

char *autnamealloc( Name )

   char *Name;
{
  chain_list *ScanChain;
  char       *SourceName;
  char       *TargetName;
  int         HashKey;
  
  if ( Name != (char *)0 )
  {
    HashKey    = 0;
    TargetName = AutNameBuffer;
    SourceName = Name;

    while ( *SourceName != '\0' ) 
    {
      *TargetName = *SourceName;

      HashKey += ( HashKey ^ ( HashKey >> 1 ) );
      HashKey += AUT_NAME_HASH_MULT * (unsigned char)*TargetName;

      TargetName++;
      SourceName++;

      while ( HashKey >= AUT_NAME_HASH_PRIME )
      {
        HashKey -= AUT_NAME_HASH_PRIME;
      }
    }

    *TargetName = '\0';
    HashKey %= AUT_NAME_HASH_SIZE;

    for ( ScanChain  = AutNameHashTable[ HashKey ];
          ScanChain != (chain_list *)0;
          ScanChain  = ScanChain->NEXT )
    {
      if (! strcmp( AutNameBuffer, (char *)ScanChain->DATA ) )
      {
        Name = (char *)ScanChain->DATA; break;
      }
    }

    if ( ScanChain == (chain_list *)0 )
    {
      Name = mbkstrdup( AutNameBuffer );
      AutNameHashTable[ HashKey ] = addchain( AutNameHashTable[ HashKey ], (void *)Name );
    }
  }

  return( Name );
}
