/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Bdd                           |
|                                                             |
| File    :                   bddlog.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H

# include <stdio.h>
# include <string.h>
# include "bddlog.h"
# include "bdderror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Get Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Get Bdd Node One                    |
|                                                             |
\------------------------------------------------------------*/

bddnode *getlogbddnodeone()
{
  return( BddLocalSystem->ONE );
}

/*------------------------------------------------------------\
|                                                             |
|                         Get Bdd Node Zero                   |
|                                                             |
\------------------------------------------------------------*/

bddnode *getlogbddnodezero()
{
  return( BddLocalSystem->ZERO );
}

/*------------------------------------------------------------\
|                                                             |
|                         Get Bdd Node Term                   |
|                                                             |
\------------------------------------------------------------*/

bddnode *getlogbddnodeterm( Index )

  bddindex Index;
{
  if ( Index < BddLocalSystem->NUMBER_INDEX )
  {
    return( getbddvarnodebyindex( (bddsystem *)0, Index ) );
  }

  return( addbddvarfirst( (bddsystem *)0 ) );
}

/*------------------------------------------------------------\
|                                                             |
|                         Get Bdd Node Not                    |
|                                                             |
\------------------------------------------------------------*/

bddnode *getlogbddnodenot( BddNode )

  bddnode *BddNode;
{
  return( applybddnodenot( (bddsystem *)0, BddNode ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Apply Bdd Node                       |
|                                                             |
\------------------------------------------------------------*/

bddnode *applylogbddnode( Oper, BddNode1, BddNode2 )

  long     Oper;
  bddnode *BddNode1;
  bddnode *BddNode2;
{
  return( applybddnode( (bddsystem *)0, Oper, BddNode1, BddNode2 ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Convert Bdd Node                     |
|                                                             |
\------------------------------------------------------------*/

ablexpr *convertlogbddnode( BddCircuit, BddNode )

  bddcircuit *BddCircuit;
  bddnode    *BddNode;
{
  return( convertbddnodeabl( (bddsystem *)0, BddCircuit->NAME_IN,
                             (bddindex  *)0, BddNode ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Add Bdd Circuit Input                |
|                                                             |
\------------------------------------------------------------*/

short addlogbddcircuitin( BddCircuit, Name )

  bddcircuit *BddCircuit;
  char       *Name;
{
  bddnode *BddNode;

  BddNode = addbddcircuitin( BddCircuit, Name, 0, BDD_IN_MODE_LAST );

  if ( BddNode == (bddnode *)0 )
  {
    return( 0 );
  }

  return( BddNode->INDEX );
}

