/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Bdd                           |
|                                                             |
| File    :                  bddtest.h                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/

# ifndef BDD_TEST_H
# define BDD_TEST_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define BDD_TEST_MAX_COMMAND      42
# define BDD_TEST_BUFFER_SIZE     512

/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

#ifndef __P
# if defined(__STDC__) ||  defined(__GNUC__)
#  define __P(x) x
# else
#  define __P(x) ()
# endif
#endif

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/

  typedef struct command
  {
    char *NAME;
    void (*FUNCTION)();
    char *COMMENT;

  } command;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  static void TestCommandExit();
  static void TestCommandLogout();
  static void TestCommandHelp();

  static void TestCommandAddInput();
  static void TestCommandRenInput();
  static void TestCommandViewInput();
  static void TestCommandAddOutput();
  static void TestCommandDelOutput();
  static void TestCommandDelAssoc();
  static void TestCommandAddAuxiliar();
  static void TestCommandAddAssoc();

  static void TestCommandViewSumProd();

  static void TestCommandViewHeath();
  static void TestCommandViewOutput();
  static void TestCommandViewBlock();
  static void TestCommandViewOper();
  static void TestCommandViewIndex();
  static void TestCommandViewAssoc();
  static void TestCommandViewSystem();
  static void TestCommandViewCircuit();

  static void TestCommandSwapVar();
  static void TestCommandGarbage();
  static void TestCommandSweep();
  static void TestCommandReorder();
  static void TestCommandOptimize();

  static void TestCommandRestrict();
  static void TestCommandCompose();
  static void TestCommandSubstitute();
  static void TestCommandRelProduct();
  static void TestCommandExist();
  static void TestCommandForall();
  static void TestCommandSimpOff();
  static void TestCommandSimpOn();

  static void TestCommandIntersect();
  static void TestCommandImply();
  static void TestCommandCofactor();
  static void TestCommandReduce();
  static void TestCommandSatisfy();
  static void TestCommandFraction();

  static void TestCommandSupport();

  static void TestCommandDumpCircuit();

# endif
