/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Fsm                           |
|                                                             |
| File    :                 Fsm Errors                        |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include "fsmerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

void fsm_error( Error, Text, File, Line )

    char  Error;
    char *Text;
    char *File;
    long  Line;
{
  char *Name;

  Name = mbkstrdup( File );
  Name[ strlen( File ) - 1 ] = '\0';

  fprintf( stderr, "%s%ld ", Name, Line );

  switch( Error )
  {
    case FSM_EXPR_NULL_ERROR :
      fprintf( stderr, "null expression !\n" );
    break;

    case FSM_UNKNOWN_ATOM_ERROR :
      fprintf( stderr, "unknown atom %s !\n", Text );
    break;

    case FSM_OPERATOR_ERROR :
      fprintf( stderr, "illegal use of operator %ld\n", (long)Text );
    break;

    case FSM_STATE_EXIST_ERROR :
      fprintf( stderr, "state %s exist already !\n", Text );
    break;

    case FSM_OUT_EXIST_ERROR :
      fprintf( stderr, "output %s exist already !\n", Text );
    break;

    case FSM_IN_EXIST_ERROR :
      fprintf( stderr, "input %s exist already !\n", Text );
    break;

    case FSM_PORT_EXIST_ERROR :
      fprintf( stderr, "port %s exist already !\n", Text );
    break;

    default :

      fprintf( stderr, "unknown internal error %d !\n", Error );
  }

  autexit( 1 );
}
