
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: fbh_getgenva.c					*/
/* date		: Aug 24 1992						*/
/* version	: v102							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: contains a specific function used to acces to the	*/
/*		  value of a fbhaviour data structure			*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H 
#include AUT_H
#include ABL_H 
#include BDD_H
#include FVH_H

/* ###--------------------------------------------------------------### */
/* function	: fbh_getgenval						*/
/* description	: Search an find a BEGEN structure (known from its name)*/
/*		  then return its value field. If the BEGEN is not found*/
/*		  a 0 pointer is returned				*/
/* called func.	:							*/
/* ###--------------------------------------------------------------### */

void *fbh_getgenval (listfbgen, fbgenname)

struct fbgen *listfbgen;	/* head of BEGEN list			*/
char         *fbgenname;	/* name of the structure 		*/

  {
  struct fbgen *ptfbgen;
  void         *value = 0;

	/* ###------------------------------------------------------### */
	/*    searching the object					*/
	/* ###------------------------------------------------------### */

  ptfbgen = listfbgen;
  while ((ptfbgen != 0) && (ptfbgen->NAME != fbgenname))
    ptfbgen = ptfbgen->NEXT;

	/* ###------------------------------------------------------### */
	/*    if found return its value field				*/
	/* ###------------------------------------------------------### */

  if (ptfbgen != 0)
    value = ptfbgen->VALUE;

  return (value);
  }
