
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: fbh_crtfbtyp.c					*/
/* date		: Aug 24 1992						*/
/* version	: v102							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: contains a specific function used to create a		*/
/*		  fbhaviour data structure				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H 
#include AUT_H
#include ABL_H 
#include BDD_H
#include FVH_H

/* ###--------------------------------------------------------------### */
/* function	: fbh_crtfbtyp						*/
/* description	: create an array of BETYPs from a list of BETYPs	*/
/* called func.	: namealloc, mbkalloc					*/
/* ###--------------------------------------------------------------### */

struct fbtyp *fbh_crtfbtyp (listfbtyp)

struct fbtyp *listfbtyp;	/* pointer on the list of fbtyps	*/

  {
  struct fbtyp *lclfbtyp = listfbtyp;
  struct fbtyp *ptfbtyp  = 0;
  int           size     = 0;

  while (lclfbtyp != 0)
    {
    lclfbtyp = lclfbtyp->NEXT;
    size++;
    }

  if (size != 0)
    {
    ptfbtyp  = (struct fbtyp *) mbkalloc (size * sizeof(struct fbtyp));
    lclfbtyp = ptfbtyp;

    while (listfbtyp != 0)
      {
      lclfbtyp->NAME   = listfbtyp->NAME;
      lclfbtyp->LEFT   = listfbtyp->LEFT;
      lclfbtyp->RIGHT  = listfbtyp->RIGHT;
      lclfbtyp->VALUE  = listfbtyp->VALUE;
      lclfbtyp->SIZE   = listfbtyp->SIZE;
      lclfbtyp->BYTE   = listfbtyp->BYTE;
      lclfbtyp->BASE   = listfbtyp->BASE;
      lclfbtyp->INDEX  = listfbtyp->INDEX;
      lclfbtyp->RESOLV = listfbtyp->RESOLV;
      lclfbtyp->CLASS  = listfbtyp->CLASS;

      lclfbtyp->NEXT   = lclfbtyp + 1;

      listfbtyp        = listfbtyp->NEXT;
      lclfbtyp++;
      }

    (lclfbtyp - 1)->NEXT = 0;
    }

  return (ptfbtyp);
  }
