#ifndef __P
# if defined(__STDC__) ||  defined(__GNUC__)
#  define __P(x) x
# else
#  define __P(x) ()
# endif
#endif
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Rtl                           |
|                                                             |
| File    :                 Rtl Errors                        |
|                                                             |
| Rtlhors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   04.07.96                        |
|                                                             |
\------------------------------------------------------------*/

# ifndef RTL_ERROR_H
# define RTL_ERROR_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define RTL_PLACE_EXIST_ERROR             0
# define RTL_TRANS_EXIST_ERROR             1
# define RTL_PORT_EXIST_ERROR              2
# define RTL_ARC_PLACE_EXIST_ERROR         3
# define RTL_ARC_TRANS_EXIST_ERROR         4
# define RTL_SIGNAL_EXIST_ERROR            6
# define RTL_VARIABLE_EXIST_ERROR          7
# define RTL_DEFINE_EXIST_ERROR            8
# define RTL_CONSTANT_EXIST_ERROR          9
# define RTL_TRANS_FATHER_UNKNOWN         10
# define RTL_PROC_EXIST_ERROR             11
# define RTL_DEL_ARC_PLACE_ERROR          12
# define RTL_DEL_ARC_TRANS_ERROR          13
# define RTL_FUNC_EXIST_ERROR             14
# define RTL_UNKNOWN_DECLAR_TYPE          15
# define RTL_ARGUMENT_EXIST_ERROR         16
# define RTL_UNDECLARED_SYMBOL            17
# define RTL_DECLAR_EXIST_ERROR           18
# define RTL_BAD_DECLAR_TYPE              19
# define RTL_BAD_ASSIGN_TYPE              20
# define RTL_ILLEGAL_INDEX_ERROR          21
# define RTL_ILLEGAL_POSITION_ERROR       22

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Macros                           |
|                                                             |
\------------------------------------------------------------*/

# define rtlerror( E, V1, V2 ) \
    (rtl_error( (int)(E), (char*)(long)(V1), (char*)(long)(V2), __FILE__, __LINE__ ))
# define rtlwarning( E, V1, V2 ) \
    (rtl_warning( (int)(E), (char*)(long)(V1), (char*)(long)(V2), __FILE__, __LINE__ ))

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void  rtl_error __P((int Error, char *Text1, char *Text2, char *File, long Line));
  extern void  rtl_warning __P((int Warning, char *Text1, char *Text2, char *File, long Line));

# endif
