/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Rtn                           |
|                                                             |
| File    :                  rtnfree.c                        |
|                                                             |
| Date    :                   04.07.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H
# include RTN_H

# include <stdio.h>
# include <string.h>
# include "rtnfree.h"
# include "rtnalloc.h"
# include "rtnerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Rtl Free Functions                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Rtl Free Figure                        |
|                                                             |
\------------------------------------------------------------*/
 
void freertlfig( Figure )

  rtlfig_list *Figure;
{
  autfreeblock( (char *)Figure );
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Assign                      |
|                                                             |
\------------------------------------------------------------*/

void freertlasg( Asg )

  rtlasg_list *Asg;
{
  autfreeheap( (char *)Asg, sizeof( rtlasg_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Register                    |
|                                                             |
\------------------------------------------------------------*/

void freertlbivex( BiVex )

  rtlbivex_list *BiVex;
{
  autfreeheap( (char *)BiVex, sizeof( rtlbivex_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Declaration                 |
|                                                             |
\------------------------------------------------------------*/

void freertldecl( Decl )

  rtldecl_list *Decl;
{
  autfreeheap( (char *)Decl, sizeof( rtldecl_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Fsm Assign                  |
|                                                             |
\------------------------------------------------------------*/

void freertlfsmasg( FsmAsg )

  rtlfsmasg_list *FsmAsg;
{
  autfreeheap( (char *)FsmAsg, sizeof( rtlfsmasg_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Fsm State                   |
|                                                             |
\------------------------------------------------------------*/

void freertlfsmstate( fsmstate )

  rtlfsmstate_list *fsmstate;
{
  autfreeheap( (char *)fsmstate, sizeof( rtlfsmstate_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Fsm Trans                   |
|                                                             |
\------------------------------------------------------------*/

void freertlfsmtrans( fsmtrans )

  rtlfsmtrans_list *fsmtrans;
{
  autfreeheap( (char *)fsmtrans, sizeof( rtlfsmtrans_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                      Rtl Free Fsm                           |
|                                                             |
\------------------------------------------------------------*/
 
void freertlfsm( Fsm )

  rtlfsm_list *Fsm;
{
  autfreeblock( (char *)Fsm );
}

/*------------------------------------------------------------\
|                                                             |
|                        Rtl Free Symbol                      |
|                                                             |
\------------------------------------------------------------*/

void freertlsym( Sym )

  rtlsym *Sym;
{
  autfreeblock( (char *)Sym );
}

