/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Sch                           |
|                                                             |
| File    :                    main.c                         |
|                                                             |
| Date    :                   08.02.95                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>

# include MUT_H
# include BEH_H
# include AUT_H
# include SCL_H
# include MLO_H
# include CNS_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Usage                            |
|                                                             |
\------------------------------------------------------------*/

void SchUsage()
{
  fprintf( stderr, "\t\tschtest [Options] Input_name [Output_name]\n\n" );
  fprintf( stdout, "\t\tOptions : -V Sets Verbose mode on\n" );
  fprintf( stdout, "\t\t          -C for CNS input file\n" );
  fprintf( stdout, "\t\t         (else MBK_LO input file)\n" );
  fprintf( stdout, "\t\t          -B to place and route\n" );
  fprintf( stdout, "\n" );

  exit( 1 );
}


/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

  int   argc;
  char *argv[];
{
  schfig_list *SchFigure;
  char        *InputFileName;
  int          Number;
  int          Index;
  char         Option;

  int   FlagVerbose  = 0;
  int   FlagInput    = SCH_FROM_LO;
  int   FlagBuild    = 0;
  
  mbkenv();
  autenv();
  cnsenv();

  InputFileName = (char *)0;

  if ( argc < 2 ) SchUsage();

  InputFileName = (char *)0;

  for ( Number = 1; Number  < argc; Number++ )
  {
    if ( argv[ Number ][ 0 ] == '-' )
    {
      for ( Index = 1; argv[ Number ][ Index ] != '\0'; Index++ )
      {
        Option = argv[ Number ][ Index ];

        switch ( Option )
        {
          case 'V' : FlagVerbose  = 1;
          break;
          case 'B' : FlagBuild    = 1;
          break;
          case 'C' : FlagInput    = SCH_FROM_CNS;
          break;
          default  : SchUsage();
        }
      }
    }
    else
    if ( InputFileName == (char *)0 ) InputFileName = argv[ Number ];
    else
    SchUsage();
  }

  if ( InputFileName  == (char *)0 ) SchUsage();

  SchFigure = getschfig( InputFileName, FlagInput );

  if ( FlagBuild )
  {
    buildschfig( SchFigure );
  }

  if ( FlagVerbose )
  {
    viewschfig( SchFigure );
  }

  delschfig( SchFigure->NAME );

  return( 0 );
}


