/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Scg                           |
|                                                             |
| File    :                   scgcns.c                        |
|                                                             |
| Date    :                   28.04.98                        |
|                                                             |
| Authors :               Picault  Stephane                   |
|                         Miramond   Benoit                   |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include BEH_H
# include SCL_H
# include MLO_H
# include CNS_H

# include <stdio.h>
# include "scg.h"
# include "scgcns.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                  Get Sch Figure From cns fig                |
|                                                             |
\------------------------------------------------------------*/

schfig_list *getschfig_from_cnsfig( FileName )

   char *FileName;
{

  cnsfig_list  *CnsFigure;
  edge_list    *CnsEdge;
  locon_list   *LoCon;
  cone_list    *CnsCone;
  schcon_list  *SchCon;
  schbox_list  *SchBox;
  schnet_list  *SchNet;
  schfig_list  *SchFigure;
  unsigned char SchDir;
  char   *name;
  cone_list    *CnsConeIn;


  if ( CNS_HEADCNSFIG != NULL )
  {
     dellofig(CNS_HEADCNSFIG->NAME);
     CNS_HEADCNSFIG = delcnsfig(CNS_HEADCNSFIG,CNS_HEADCNSFIG);
  }
  CnsFigure  = getcnsfig( FileName );
  
  SchFigure  = addschfig( CnsFigure->NAME );
  SchFigure->SOURCE = (void *)CnsFigure;
  SchFigure->SOURCE_TYPE = SCH_SOURCE_CNSFIG; 
 
  /* connecteurs externes */
  
  
  for ( LoCon  = CnsFigure->LOCON;
        LoCon != (locon_list *)0;
        LoCon  = LoCon->NEXT )
  {
    if ( LoCon->DIRECTION == CNS_VDDC) continue;
    if ( LoCon->DIRECTION == CNS_VSSC) continue;
    if ( LoCon->DIRECTION == IN ) SchDir = SCH_CON_IN;
    else                          SchDir = SCH_CON_OUT;

    SchCon         = addschfigcon( SchFigure, LoCon->NAME, SchDir );
    SchCon->SOURCE = (void *)LoCon;
    SchCon->SOURCE_TYPE = SCH_SOURCE_LOCON;
    
    SchNet          = addschnet(SchFigure );
    LoCon->USER     = addptype(LoCon->USER, SCH_NET_TYPE, SchNet);
  
    addschnetcon(SchNet, SchCon);  
  }
/* */ SchFigure->CON_IN = (schcon_list *)reverse((chain_list *)SchFigure->CON_IN);
/* */ SchFigure->CON_OUT = (schcon_list *)reverse((chain_list *)SchFigure->CON_OUT);

  
  /* box */
  
  for ( CnsCone  = CnsFigure->CONE;
        CnsCone != (cone_list *)0;
        CnsCone  = CnsCone->NEXT )
  {
    SchBox = addschbox( SchFigure, CnsCone->NAME );
    SchBox->SOURCE = (void *)CnsCone;
    SchBox->SOURCE_TYPE = SCH_SOURCE_CNSCONE;
   
    CnsCone->USER = addptype(CnsCone->USER,SCH_BOX_TYPE,SchBox);
    
    if ((CnsCone->TYPE & CNS_EXT) == CNS_EXT)
    {
      LoCon  = (locon_list *)getptype(CnsCone->USER, CNS_EXT)->DATA;
      if (LoCon->DIRECTION != IN)
        SchNet = (schnet_list *)getptype(LoCon->USER, SCH_NET_TYPE)->DATA;
      else SchNet = addschnet( SchFigure );
    } 
    else
      SchNet = addschnet( SchFigure );
    
    CnsCone->USER    = addptype(CnsCone->USER, SCH_NET_TYPE, SchNet);

    SchCon = addschboxconout( SchFigure, SchBox, CnsCone->NAME);
    
    SchCon->ROOT   = SchBox;

    SchCon->SOURCE = CnsCone;
    SchCon->SOURCE_TYPE = SCH_SOURCE_CNSCONE;

    addschnetcon( SchNet, SchCon);
  }
  
  for ( CnsCone  = CnsFigure->CONE;
        CnsCone != (cone_list *)0;
        CnsCone  = CnsCone->NEXT )
  {
    SchBox = (schbox_list *)getptype(CnsCone->USER, SCH_BOX_TYPE)->DATA;

    /* connecteurs d entree */
    
    for ( CnsEdge  = CnsCone->INCONE;
          CnsEdge != (edge_list *)0;
	  CnsEdge  = CnsEdge->NEXT )
    {
       if ((CnsEdge->TYPE & CNS_EXT)==CNS_EXT)
      {
           LoCon = CnsEdge->UEDGE.LOCON;
           SchNet = (schnet_list *)getptype(LoCon->USER , SCH_NET_TYPE )->DATA;
           name = CnsEdge->UEDGE.LOCON->NAME;
      }
    else    
      {
           name = CnsEdge->UEDGE.CONE->NAME;
           CnsConeIn = CnsEdge->UEDGE.CONE;
           SchNet = (schnet_list *)getptype(CnsConeIn->USER , SCH_NET_TYPE )->DATA;
      }
      SchCon = addschboxconin( SchFigure, SchBox, name); 

      SchCon->ROOT   = SchBox;

      SchCon->SOURCE = CnsEdge;
      SchCon->SOURCE_TYPE = SCH_SOURCE_CNSEDGE;

      addschnetcon( SchNet, SchCon);
    }
/*  */  SchBox->CON_IN = (schcon_list *)reverse((chain_list *)SchBox->CON_IN);

  }
  
  return( SchFigure );
}
