/*------------------------------------------------------------\
|                                                             |
| Tool    :                     SYF                           |
|                                                             |
| File    :                 kis_parse.c                       |
|                                                             |
| Authors :                  C. Sarwary                       |
|                     Modified by Jacomme Ludovic             |
|                                                             |
| Date    :                   01.11.94                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include FTL_H

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include "syf_fsm.h"
# include "syf_error.h"
# include "kis_parse.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Privates                           |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        SyfKissParse                         |
|                                                             |
\------------------------------------------------------------*/

fsmfig_list *SyfKissParse( Name, FlagScan )

  char *Name;
  char  FlagScan;
{
  fsmfig_list    *FsmFigure;
  syfinfo        *SyfInfo;
  fsmstate_list  *ScanState;
  fsmout_list    *ScanOut;

  FsmFigure = Syfaddfsmfig( Name );
  SyfInfo   = FSM_SYF_INFO( FsmFigure );

  SyfInfo->SCAN_PATH = FlagScan;

  SyfInfo->CURRENT_STATE = namealloc( "current_state" );
  SyfInfo->RETURN_STATE  = namealloc( "return_state"  );
  SyfInfo->NEXT_STATE    = namealloc( "next_state"    );
  SyfInfo->NUMBER_CTRL   = FSM_MAX_CTRL;

  loadfsmfig( FsmFigure, Name );

  ScanState = FsmFigure->STAR_STATE;

  if ( ScanState != (fsmstate_list *)0 )
  {
    *ScanState->PREV = ScanState->NEXT;

    if ( ScanState->NEXT != (fsmstate_list *)0 )
    {
      ScanState->NEXT->PREV = ScanState->PREV;
    }

    FsmFigure->NUMBER_STATE--;
  }

  if ( FlagScan )
  {
    SyfInfo->SCAN_IN   = namealloc( "scan_in"   );
    SyfInfo->SCAN_OUT  = namealloc( "scan_out"  );
    SyfInfo->SCAN_TEST = namealloc( "scan_test" );

    addfsmport( FsmFigure, SyfInfo->SCAN_IN  , FSM_DIR_IN , FSM_TYPE_BIT );
    addfsmport( FsmFigure, SyfInfo->SCAN_TEST, FSM_DIR_IN , FSM_TYPE_BIT );
    addfsmport( FsmFigure, SyfInfo->SCAN_OUT , FSM_DIR_OUT, FSM_TYPE_BIT );

    addfsmin( FsmFigure , SyfInfo->SCAN_TEST );
    addfsmin( FsmFigure , SyfInfo->SCAN_IN   );
    addfsmout( FsmFigure, SyfInfo->SCAN_OUT  );
  }

  for ( ScanState  = FsmFigure->STATE;
        ScanState != (fsmstate_list *)0;
        ScanState  = ScanState->NEXT )
  {
    Syfaddfsmsyfstate( FsmFigure, ScanState );
  }

  for ( ScanOut  = FsmFigure->OUT;
        ScanOut != (fsmout_list *)0;
        ScanOut  = ScanOut->NEXT )
  {
    Syfaddfsmsyfout( ScanOut );
  }

  return( FsmFigure );
}
