/*------------------------------------------------------------\
|                                                             |
| Tool    :                     SYF                           |
|                                                             |
| File    :                  syf_must.h                       |
|                                                             |
| Authors :                  C. Sarwary                       |
|                     Modified by Jacomme Ludovic             |
|                                                             |
| Date    :                   01.11.94                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef SYF_MUSTANG_H
# define SYF_MUSTANG_H

/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

# define HEAP_FATHER( Node )      ( ( ( ( Node ) + 1 ) >> 1 ) - 1 )
# define HEAP_LEFT_CHILD( Node )  ( ( ( ( Node ) + 1 ) << 1 ) - 1 )
# define HEAP_RIGHT_CHILD( Node )   ( ( ( Node ) + 1 ) << 1 )

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void SyfFsmMustangEncode();
  extern void SyfFsmGetMustangTrans();
  extern void SyfFsmGetMustangOut();
  extern void SyfFsmGetMustangCtrl();
  extern void SyfFsmGetMustangEdge();
  extern long SyfFsmGetMustangCost();

  extern void SyfFsmGetSortArray();


# ifdef SYF_DEBUG

/*------------------------------------------------------------\
|                                                             |
|                        View Functions                       |
|                                                             |
\------------------------------------------------------------*/

  extern void SyfFsmViewMustangOut();
  extern void SyfFsmViewMustangTrans();
  extern void SyfFsmViewMustangCtrl();
  extern void SyfFsmViewMustangEdge();

# endif

# endif
