/*------------------------------------------------------------\
|                                                             |
| Tool    :                     VASY                          |
|                                                             |
| File    :                 vasy_drvvex.h                     |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   25.08.97                        |
|                                                             |
\------------------------------------------------------------*/

# ifndef VASY_DRVVEX_H
# define VASY_DRVVEX_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define VASY_DRIVE_VEX_LENGTH        80

# define VASY_DRIVE_VEX_VECTOR_MASK   VEX_NODE_USER1_MASK

/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

# define VasyDriveVexExprVhdl( F, R, E )     (VasyDriveVexExpr( (F), (R), (E), 0 ))
# define VasyDriveVexExprVerilog( F, R, E )  (VasyDriveVexExpr( (F), (R), (E), 1 ))

# define IsVasyDriveVexVector( N )    ( (N)->TYPE &   VASY_DRIVE_VEX_VECTOR_MASK )
# define SetVasyDriveVexVector( N )   ( (N)->TYPE |=  VASY_DRIVE_VEX_VECTOR_MASK )
# define ClearVasyDriveVexVector( N ) ( (N)->TYPE &= ~VASY_DRIVE_VEX_VECTOR_MASK )

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void VasyDriveVexExpr();

# endif
