/*------------------------------------------------------------\
|                                                             |
| Tool    :                     VASY                          |
|                                                             |
| File    :                 vasy_error.h                      |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   25.08.97                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef VASY_ERROR_H
# define VASY_ERROR_H

/*------------------------------------------------------------\
|                                                             |
|                           Errors                            |
|                                                             |
\------------------------------------------------------------*/

# define VASY_ILLEGAL_ASSIGN_ERROR          0
# define VASY_NO_WAIT_IN_PROCESS_ERROR      1
# define VASY_NOT_YET_IMPLEMENTED_ERROR     2
# define VASY_LOOP_IN_SIMULATION            3
# define VASY_ERROR_IN_SIMULATION           4
# define VASY_ERROR_IN_SUPPORT              5
# define VASY_ERROR_IN_VEX2BDD              6
# define VASY_ERROR_IN_ABL2VEX              7
# define VASY_ERROR_IN_DRVVEX               8
# define VASY_ERROR_OPERATOR_NOT_SUPPORTED  9
# define VASY_ERROR_IN_UNROLL_LOOP         10
# define VASY_LOOP_IN_REDUCTION            11
# define VASY_ERROR_ILLEGAL_USE_OF         12
# define VASY_ERROR_CONVERT_WRONG_TYPE     13

/*------------------------------------------------------------\
|                                                             |
|                           Warnings                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

# define VasyError( E, T ) \
                              \
  VasyDisplayError( __FILE__, __LINE__, (E), (vpnline_list *)0, (T) )

# define VasyWarning( W, T ) \
                                \
  VasyDisplayWarning( __FILE__, __LINE__, (W), (vpnline_list *)0, (T) )

# define VasyErrorLine( E, L, T ) \
                              \
  VasyDisplayError( __FILE__, __LINE__, (E), (vpnline_list *)(L), (T) )

# define VasyWarningLine( W, L, T ) \
                                \
  VasyDisplayWarning( __FILE__, __LINE__, (W), (vpnline_list *)(L), (T) )

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void VasyDisplayError();
  extern void VasyDisplayWarning();

# endif
