/*------------------------------------------------------------\
|                                                             |
| Tool    :                    VASY                           |
|                                                             |
| File    :                 vasy_func.c                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   25.08.97                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>

# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H
# include VTL_H

# include "vasy_func.h"
# include "vasy_redact.h"
# include "vasy_debug.h"
# include "vasy_error.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static vpnline_list *VasyVpnLine = (vpnline_list *)0;

/*------------------------------------------------------------\
|                                                             |
|                      Private variables                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

# if 0
/*------------------------------------------------------------\
|                                                             |
|                      VasyFuncAddVpnDefine                   |
|                                                             |
\------------------------------------------------------------*/

static vpndecl_list *VasyFuncAddVpnDefine( VpnFigure, VpnProc, Width, DefBase )

  vpnfig_list    *VpnFigure;
  vpnproc_list   *VpnProc;
  unsigned short  Width;
  unsigned char   DefBase;
{
  vpndecl_list *DefDeclar;
  vexexpr      *DefAtom;
  char         *FatherName;
  char          Buffer[ 128 ];
  unsigned char NewBase;
  long          Number;

  FatherName = VpnProc->NAME;
  Number     = GetVpnNumDeclDef( VpnFigure );

  sprintf( Buffer, "%s_std_%ld", FatherName, Number );

  NewBase = getvextypescalar( DefBase );

  if ( ( isvextypevector( DefBase ) ) &&
       ( ( Width   >  1           ) ||
         ( NewBase == DefBase     ) ) )
  {
    DefAtom = createvexatomvec( Buffer, Width - 1, 0 );
  }
  else
  {
    DefAtom = createvexatombit( Buffer );
    DefBase = NewBase;
  }

  DefDeclar = addvpndeclprocdef( VpnFigure, VpnProc, DefAtom, DefBase );

  return( DefDeclar );
}
# endif

/*------------------------------------------------------------\
|                                                             |
|                       VasyFuncSubstVexStdFunc               |
|                                                             |
\------------------------------------------------------------*/

static vexexpr *VasyFuncSubstVexStdFunc( Expr )

  vexexpr *Expr;
{
  vexexpr    *Operand;
  vexexpr    *VexInt;
  chain_list *ScanChain;
  long        Length;
  int         FuncId;
  char       *FuncName;

  if ( ( IsVexNodeOper( Expr ) ) ||
       ( IsVexNodeFunc( Expr ) ) )
  {
    for ( ScanChain  = Expr->OPERAND;
          ScanChain != (chain_list *)0;
          ScanChain  = ScanChain->NEXT )
    {
      Operand = GetVexOperand( ScanChain );
      Operand = VasyFuncSubstVexStdFunc( Operand );
      SetVexOperand( ScanChain, Operand );
    }

    if ( IsVexNodeFunc( Expr ) )
    {
      FuncName = GetVexFuncValue( Expr );
      FuncId   = getvexstdfuncid( FuncName );

      if ( FuncId != -1 )
      {
        switch ( FuncId )
        {
          case VEX_STD_TO_BIT                :
          case VEX_STD_TO_BITVECTOR          :
          case VEX_STD_TO_STDULOGIC          :
          case VEX_STD_TO_STDLOGICVECTOR     :
          case VEX_STD_TO_STDULOGICVECTOR    :
          case VEX_STD_TO_X01                :
          case VEX_STD_TO_X01Z               :
          case VEX_STD_TO_UX01               :
          case VEX_STD_CONV_INTEGER          :
          case VEX_STD_RISING_EDGE           :
          case VEX_STD_FALLING_EDGE          :
          case VEX_STD_STD_LOGIC_VECTOR      :
          case VEX_STD_STD_ULOGIC_VECTOR     :
          case VEX_STD_SIGNED                :
          case VEX_STD_UNSIGNED              :
          case VEX_STD_TO_INTEGER            :

            Operand = GetVexOperand( Expr->OPERAND );
            SetVexOperand( Expr->OPERAND, (vexexpr *)0 );
            freevexexpr( Expr );

            if ( FuncId == VEX_STD_FALLING_EDGE )
            {
              Expr    = createvexunaryexpr( VEX_EVENT, 1, dupvexexpr( Operand ) );
              Operand = createvexunaryexpr( VEX_NOT  , 1, Operand               );
              Expr    = createvexbinexpr(   VEX_AND  , 1, Expr, Operand         );
            }
            else
            if ( FuncId == VEX_STD_RISING_EDGE )
            {
              Expr = createvexunaryexpr( VEX_EVENT, 1, dupvexexpr( Operand ) );
              Expr = createvexbinexpr(   VEX_AND  , 1, Expr, Operand         );
            }
            else
            {
              Expr = Operand;
            }

          break;

          case VEX_STD_TO_UNSIGNED           :
          case VEX_STD_TO_SIGNED             :
          case VEX_STD_CONV_UNSIGNED         :
          case VEX_STD_CONV_SIGNED           :
          case VEX_STD_CONV_STD_LOGIC_VECTOR :

            Operand  = GetVexOperand( Expr->OPERAND       );
            VexInt   = GetVexOperand( Expr->OPERAND->NEXT );

            if ( evalvexatomlong( VexInt, &Length ) )
            {
              VasyErrorLine( VASY_ERROR_ILLEGAL_USE_OF,
                             VasyVpnLine, GetVexFuncValue( Expr ) );
            }

            if ( ( Operand->WIDTH != Length    ) &&
                 ( IsVexNodeAtom( Operand )    ) &&
                 ( IsVexAtomLiteral( Operand ) ) )
            {
              Operand = extendvexatomsign( Operand, Length );
            }

            if ( Operand->WIDTH == Length )
            {
              SetVexOperand( Expr->OPERAND, (vexexpr *)0 );
              freevexexpr( Expr );

              Expr = Operand;
            }
            else
            {
              VasyErrorLine( VASY_NOT_YET_IMPLEMENTED_ERROR,
                             VasyVpnLine, "standard function" );
            }

          break;

          default : 
          
          /* fprintf( stdout, "%s\n", FuncName ); */
            VasyErrorLine( VASY_NOT_YET_IMPLEMENTED_ERROR, VasyVpnLine, "standard function" );

          /* VEX_STD_IS_X
             VEX_STD_ABS
             VEX_STD_SHL
             VEX_STD_SHR
             VEX_STD_EXT
             VEX_STD_SXT
             VEX_STD_SHIFT_LEFT
             VEX_STD_SHIFT_RIGHT
             VEX_STD_ROTATE_LEFT
             VEX_STD_ROTATE_RIGHT
             VEX_STD_RESIZE
          */
        }
      }
    }
  }

  return( Expr );
}

/*------------------------------------------------------------\
|                                                             |
|                       VasyFuncVpnProc                       |
|                                                             |
\------------------------------------------------------------*/

static void VasyFuncVpnProc( VpnFigure, VpnProc )

  vpnfig_list  *VpnFigure;
  vpnproc_list *VpnProc;
{
  vpntrans_list *VpnTrans;
  vpnact_list   *VpnAction;

  if ( IsVasyDebugLevel0() )
  {
    VasyPrintf( stdout, "  --> VasyFuncVpnProc %s\n", VpnProc->NAME );
  }

  for ( VpnTrans  = VpnProc->TRANS;
        VpnTrans != (vpntrans_list *)0;
        VpnTrans  = VpnTrans->NEXT )
  {
    for ( VpnAction  = VpnTrans->ACT;
          VpnAction != (vpnact_list *)0;
          VpnAction  = VpnAction->NEXT )
    {
      VasyVpnLine = VpnAction->LINE;
      VpnAction->VEX_EXPR = VasyFuncSubstVexStdFunc( VpnAction->VEX_EXPR );
    }
  }

  if ( IsVasyDebugLevel0() )
  {
    VasyPrintf( stdout, "  <-- VasyFuncVpnProc %s\n", VpnProc->NAME );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                       VasyFuncVpnFig                        |
|                                                             |
\------------------------------------------------------------*/

void VasyFuncVpnFig( VpnFigure )

 vpnfig_list *VpnFigure;
{
  vpnproc_list *VpnProc;

  if ( IsVasyDebugLevel0() )
  {
    VasyPrintf( stdout, "--> VasyFuncVpnFig %s\n", VpnFigure->NAME );
  }

  if ( IsVasyDebugLevel1() )
  {
    VasyDebugSaveVpnFig( VpnFigure );
  }

  for ( VpnProc  = VpnFigure->PROCESS;
        VpnProc != (vpnproc_list *)0;
        VpnProc  = VpnProc->NEXT )
  {
    VasyFuncVpnProc( VpnFigure, VpnProc );
  }

  if ( IsVasyDebugLevel1() )
  {
    VasyDebugSaveVpnFig( VpnFigure );
  }

  if ( IsVasyDebugLevel0() )
  {
    VasyPrintf( stdout, "<-- VasyFuncVpnFig %s\n\n", VpnFigure->NAME );
  }
}
