/*------------------------------------------------------------\
|                                                             |
| Tool    :                     VASY                           |
|                                                             |
| File    :                 vasy_simul.h                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   28.08.97                        |
|                                                             |
\------------------------------------------------------------*/

# ifndef VASY_SIMUL_H
# define VASY_SIMUL_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                             Loop                            |
|                                                             |
\------------------------------------------------------------*/

# define VASY_MAX_SIMULATE_LOOP       1000

/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

# define SetVasySymbolInOut( S, IO ) ((S)->FLAGS = IO )
# define GetVasySymbolInOut( S )     ((S)->FLAGS      )

# define SetVasySymbolEvent( S, E ) ((S)->USER = (void *)E )
# define GetVasySymbolEvent( S )    ((paevt_list *)(S)->USER )

# define IncVasySimulateLoop( O )   ((O)->FLAGS++  )
# define ClearVasySimulateLoop( O ) ((O)->FLAGS = 0)
# define IsVasySimulateLoop( O )    ((O)->FLAGS ==  VASY_MAX_SIMULATE_LOOP)

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/

  typedef struct vasysimul
  {
    char  *VALUE;
    short  WIDTH;
    short  SIGNED;

  } vasysimul;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void      VasySimulateDelSimul();
  extern vasysimul *VasySimulateVexExpr();
  extern void      VasySimulateVpnProc();

# endif
