
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: vbh_crtvbrin.c					*/
/* date		: Aug 24 1992						*/
/* version	: v102							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: contains a specific function used to create a		*/
/*		  behaviour data structure				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H 
#include AUT_H
#include VEX_H 
#include VBH_H 

/* ###--------------------------------------------------------------### */
/* function	: vbh_crtvbtyp						*/
/* description	: create an array of BETYPs from a list of BETYPs	*/
/* called func.	: namealloc, autallocblock					*/
/* ###--------------------------------------------------------------### */

struct vbtyp *vbh_crtvbtyp (listvbtyp)

struct vbtyp *listvbtyp;	/* pointer on the list of vbtyps	*/

{
  struct vbtyp *lclvbtyp = listvbtyp;
  struct vbtyp *ptvbtyp  = NULL;
  int           size     = 0;

  while (lclvbtyp != NULL)
  {
    lclvbtyp = lclvbtyp->NEXT;
    size++;
  }

  if (size != 0)
  {
    ptvbtyp  = (struct vbtyp *) autallocblock (size * sizeof(struct vbtyp));
    lclvbtyp = ptvbtyp;

    while (listvbtyp != NULL)
    {
      lclvbtyp->NAME   = listvbtyp->NAME;
      lclvbtyp->LEFT   = listvbtyp->LEFT;
      lclvbtyp->RIGHT  = listvbtyp->RIGHT;
      lclvbtyp->VALUE  = listvbtyp->VALUE;
      lclvbtyp->SIZE   = listvbtyp->SIZE;
      lclvbtyp->BYTE   = listvbtyp->BYTE;
      lclvbtyp->BASE   = listvbtyp->BASE;
      lclvbtyp->INDEX  = listvbtyp->INDEX;
      lclvbtyp->RESOLV = listvbtyp->RESOLV;
      lclvbtyp->CLASS  = listvbtyp->CLASS;

      lclvbtyp->NEXT   = lclvbtyp + 1;

      listvbtyp        = listvbtyp->NEXT;
      lclvbtyp++;
    }

    (lclvbtyp - 1)->NEXT = NULL;
  }

  return (ptvbtyp);
}
