/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vbh                           |
|                                                             |
| File    :                   vbhsimp.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H
# include VBH_H

# include <stdio.h>
# include <string.h>

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        View  Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Ifs                       |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbifs( ScanIfs  )

  vbifs_list  *ScanIfs;
{
  ScanIfs->CND = simpvexexpr( ScanIfs->CND );

  if ( ScanIfs->CNDTRUE != (ptype_list *)0 )
  {
    vbh_simpvbinst( ScanIfs->CNDTRUE );
  }

  if ( ScanIfs->CNDFALSE != (ptype_list *)0 )
  {
    vbh_simpvbinst( ScanIfs->CNDFALSE );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Var                       |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbvar( ScanVar  )

  vbvar_list  *ScanVar;
{
  ScanVar->TARGET = simpvexexpr( ScanVar->TARGET );
  ScanVar->VEX    = simpvexexpr( ScanVar->VEX );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Asg                       |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbasg( ScanAsg  )

  vbasg_list  *ScanAsg;
{
  ScanAsg->TARGET = simpvexexpr( ScanAsg->TARGET );
  ScanAsg->VEX    = simpvexexpr( ScanAsg->VEX );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Agr                       |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbagr( ScanAgr  )

  vbagr_list  *ScanAgr;
{
  vbh_simpvbinst( ScanAgr->ASSIGN );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Case                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbcas( ScanCase  )

  vbcas_list  *ScanCase;
{
  vbcho_list    *ScanChoice;
  int            Offset;

  ScanCase->VEX = simpvexexpr( ScanCase->VEX );

  for ( Offset = 0; Offset < ScanCase->SIZE; Offset++ )
  {
    ScanChoice = &ScanCase->CHOICE[ Offset ];
    vbh_simpvbinst( ScanChoice->INSTRUCTION );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Wait                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbwas( ScanWait  )

  vbwas_list  *ScanWait;
{
  if ( ScanWait->CND != (vexexpr *)0 )
  {
    ScanWait->CND = simpvexexpr( ScanWait->CND );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh For                       |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbfor( ScanFor )

  vbfor_list  *ScanFor;
{
  ScanFor->VARIABLE = simpvexexpr( ScanFor->VARIABLE );

  vbh_simpvbinst( ScanFor->INSTRUCTION );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh While                     |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbwhi( ScanWhile )

  vbwhi_list  *ScanWhile;
{
  if ( ScanWhile->CND != (vexexpr *)0 )
  {
    ScanWhile->CND = simpvexexpr( ScanWhile->CND );
  }

  vbh_simpvbinst( ScanWhile->INSTRUCTION );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Loop                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvblop( ScanLoop )

  vblop_list  *ScanLoop;
{
  vbh_simpvbinst( ScanLoop->INSTRUCTION );
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Exit                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbext( ScanExit  )

  vbext_list  *ScanExit;
{
  if ( ScanExit->CND != (vexexpr *)0 )
  {
    ScanExit->CND = simpvexexpr( ScanExit->CND );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Next                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbnxt( ScanNext  )

  vbnxt_list  *ScanNext;
{
  if ( ScanNext->CND != (vexexpr *)0 )
  {
    ScanNext->CND = simpvexexpr( ScanNext->CND );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Return                    |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbret( ScanReturn  )

  vbret_list  *ScanReturn;
{
  if ( ScanReturn->RET != (vexexpr *)0 )
  {
    ScanReturn->RET = simpvexexpr( ScanReturn->RET );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Call                      |
|                                                             |
\------------------------------------------------------------*/

static void loc_simpvbcal( ScanCall  )

  vbcal_list  *ScanCall;
{
  if ( ScanCall->CALL != (vexexpr *)0 )
  {
    ScanCall->CALL = simpvexexpr( ScanCall->CALL );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                    Local View Vbh Instruction               |
|                                                             |
\------------------------------------------------------------*/

void vbh_simpvbinst( Instruction )

  ptype_list *Instruction;
{
  while ( Instruction != (ptype_list *)0 )
  {
    switch ( Instruction->TYPE )
    {
      case VBH_BEIFS : loc_simpvbifs( Instruction->DATA );
      break;

      case VBH_BEASG : loc_simpvbasg( Instruction->DATA );
      break;

      case VBH_BEVAR : loc_simpvbvar( Instruction->DATA );
      break;

      case VBH_BECAS : loc_simpvbcas( Instruction->DATA );
      break;

      case VBH_BEWAS : loc_simpvbwas( Instruction->DATA );
      break;

      case VBH_BEFOR : loc_simpvbfor( Instruction->DATA );
      break;

      case VBH_BEWHI : loc_simpvbwhi( Instruction->DATA );
      break;

      case VBH_BELOP : loc_simpvblop( Instruction->DATA );
      break;

      case VBH_BENXT : loc_simpvbnxt( Instruction->DATA );
      break;

      case VBH_BEEXT : loc_simpvbext( Instruction->DATA );
      break;

      case VBH_BERET : loc_simpvbret( Instruction->DATA );
      break;

      case VBH_BECAL : loc_simpvbcal( Instruction->DATA );
      break;

      case VBH_BEAGR : loc_simpvbagr( Instruction->DATA );
      break;
    }

    Instruction = Instruction->NEXT;
  }
}

/*------------------------------------------------------------\
|                                                             |
|                         View Vbh Figure                     |
|                                                             |
\------------------------------------------------------------*/

void vbh_simpvbfig( Figure )

  vbfig_list *Figure;
{
  vbaux_list *BeAux;
  vbcst_list *BeCst;
  vbpor_list *BePor;
  vbpcs_list *BePcs;
  vbfun_list *BeFun;
  vbarg_list *BePar;
  vbvar_list *BeVar;
  ptype_list *ScanPtype;

  for ( BePor  = Figure->BEPOR;
        BePor != (vbpor_list *)0;
        BePor  = BePor->NEXT )
  {
    BePor->TARGET = simpvexexpr( BePor->TARGET );
    if ( BePor->VEX != (vexexpr *)0 )
    {
      BePor->VEX = simpvexexpr( BePor->VEX );
    }
  }

  for ( BeAux  = Figure->BEAUX;
        BeAux != (vbaux_list *)0;
        BeAux  = BeAux->NEXT )
  {
    BeAux->TARGET = simpvexexpr( BeAux->TARGET );
    if ( BeAux->VEX != (vexexpr *)0 )
    {
      BeAux->VEX = simpvexexpr( BeAux->VEX );
    }
  }

  for ( BeCst  = Figure->BECST;
        BeCst != (vbcst_list *)0;
        BeCst  = BeCst->NEXT )
  {
    BeCst->TARGET = simpvexexpr( BeCst->TARGET );
    if ( BeCst->VEX != (vexexpr *)0 )
    {
      BeCst->VEX = simpvexexpr( BeCst->VEX );
    }
  }

  for ( BeFun  = Figure->BEFUN;
        BeFun != (vbfun_list *)0;
        BeFun  = BeFun->NEXT )
  {
    for ( BePar  = BeFun->ARGUMENT;
          BePar != (vbarg_list *)0;
          BePar  = BePar->NEXT )
    {
      BePar->TARGET = simpvexexpr( BePar->TARGET );
    }

    if ( BeFun->RETURN != (vbarg_list *)0 )
    {
      BePar = BeFun->RETURN;

      BePar->TARGET = simpvexexpr( BePar->TARGET );
    }

    for ( ScanPtype  = BeFun->VARIABLE;
          ScanPtype != (ptype_list *)0;
          ScanPtype  = ScanPtype->NEXT )
    {
      BeVar = (vbvar_list *)ScanPtype->DATA;

      BeVar->TARGET = simpvexexpr( BeVar->TARGET );
      if ( BeVar->VEX != (vexexpr *)0 )
      {
        BeVar->VEX = simpvexexpr( BeVar->VEX );
      }
    }

    vbh_simpvbinst( BeFun->INSTRUCTION );
  }

  for ( BePcs  = Figure->BEPCS;
        BePcs != (vbpcs_list *)0;
        BePcs  = BePcs->NEXT )
  {
    for ( ScanPtype  = BePcs->VARIABLE;
          ScanPtype != (ptype_list *)0;
          ScanPtype  = ScanPtype->NEXT )
    {
      BeVar = (vbvar_list *)ScanPtype->DATA;

      BeVar->TARGET = simpvexexpr( BeVar->TARGET );
      if ( BeVar->VEX != (vexexpr *)0 )
      {
        BeVar->VEX = simpvexexpr( BeVar->VEX );
      }
    }

    vbh_simpvbinst( BePcs->INSTRUCTION );
  }
}
