/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vex                           |
|                                                             |
| File    :                   vexdel.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H

# include <stdio.h>
# include "vexdel.h"
# include "vexerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Varivexes                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Del  Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Del Vex Expr                        |
|                                                             |
\------------------------------------------------------------*/

void delvexexpr( Expr )

  vexexpr *Expr;
{
  chain_list *ScanOper;

  if ( ! IsVexNodeAtom( Expr ) )
  {
    for ( ScanOper  = Expr->OPERAND;
          ScanOper != (chain_list *)0;
          ScanOper  = ScanOper->NEXT )
    {
      freevexexpr( GetVexOperand( ScanOper ) );
    }

    freechain( Expr->OPERAND );
  }

  freevexnode( Expr );
}

/*------------------------------------------------------------\
|                                                             |
|                         Del Vex Expr Number                 |
|                                                             |
\------------------------------------------------------------*/

void delvexexprnum( Expr, Number )

  vexexpr *Expr;
  int      Number;
{
  chain_list **PrevOper;
  chain_list  *ScanOper;
  int          Counter;

  if ( ! IsVexNodeAtom( Expr ) )
  {
    PrevOper = &Expr->OPERAND;
    Counter  = 0;

    for ( ScanOper  = Expr->OPERAND;
          ScanOper != (chain_list *)0;
          ScanOper  = ScanOper->NEXT )
    {
      if ( Counter == Number )
      {
        *PrevOper = ScanOper->NEXT;
        ScanOper->NEXT = (chain_list *)0;

        delvexexpr( GetVexOperand( ScanOper ) );
        freechain( ScanOper );

        return;
      }
      
      Counter  = Counter + 1;
      PrevOper = &ScanOper->NEXT;
      ScanOper = ScanOper->NEXT;
    }
  }
}
