/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vex                           |
|                                                             |
| File    :                 vexextend.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H

# include <stdio.h>
# include <string.h>
# include "vexextend.h"
# include "vexerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Extend Functions                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Extend Vex Atom Sign                   |
|                                                             |
\------------------------------------------------------------*/

vexexpr *extendvexatomsign( Expr, Width )

  vexexpr *Expr;
  short    Width;
{
  char    *Value;
  vexexpr *Atom;
  vexexpr *Result;
  char     Buffer[ 128 ];
  int      Index;
  int      Target;
  int      Extend;
  char     Sign;
  char     Limit;

  if ( IsVexNodeAtom( Expr ) )
  {
    Value = GetVexAtomValue( Expr );

    if ( IsVexAtomLiteral( Expr ) )
    {
      if ( Expr->WIDTH < Width )
      {
/*
**    "1xxxx" -> "1111xxxx"
*/
        Extend = Width - Expr->WIDTH;

        if ( IsVexNodeSigned( Expr ) ) Sign = Value[ 1 ];
        else                           Sign = '0';

        Target = 0;
        Buffer[ Target++ ] = '"';

        for ( Index = 1; Index <= Extend; Index++ )
        {
          Buffer[ Target++ ] = Sign;
        }

        for ( Index = 1; Index <= Expr->WIDTH; Index++ )
        {
          Buffer[ Target++ ] = Value[ Index ];
        }

        Buffer[ Target++ ] = '"';
        Buffer[ Target++ ] = '\0';

        SetVexAtomValue( Expr, namealloc( Buffer ) );

        Expr->WIDTH = Width;
        Expr->LEFT  = Width - 1;
        Expr->RIGHT = 0;
      }
      else
      if ( Expr->WIDTH > Width )
      {
/*
**    "1111xxxx" -> "1xxxx"
*/
        Extend = (Expr->WIDTH + 1) - Width;

        if ( IsVexNodeSigned( Expr ) ) Sign = Value[ 1 ];
        else                           Sign = '0';

        Target = 0;

        if ( Width > 1 ) Limit = '"';
        else             Limit = '\'';

        Buffer[ Target++ ] = Limit;

        for ( Index = 1; Index <= Extend; Index++ )
        {
          if ( Value[ Index ] != Sign ) return( (vexexpr *)0 );
        }

        for ( Index = Extend; Index <= Expr->WIDTH; Index++ )
        {
          Buffer[ Target++ ] = Value[ Index ];
        }

        Buffer[ Target++ ] = Limit;
        Buffer[ Target++ ] = '\0';

        SetVexAtomValue( Expr, namealloc( Buffer ) );

        Expr->WIDTH = Width;
        Expr->LEFT  = Width - 1;
        Expr->RIGHT = 0;
      }

      return( Expr );
    }
    else
    if ( IsVexAtomVector( Expr ) )
    {
      if ( Expr->WIDTH < Width )
      {
/*
**    "1xxxx" -> "1111xxxx"
*/
        Extend = Width - Expr->WIDTH;

        if ( IsVexNodeSigned( Expr ) )
        {
          Value  = GetVexAtomValue( Expr );
          Result = createvexoper( VEX_CONCAT, Width );

          addvexhexpr( Result, Expr );

          for ( Index = 1; Index <= Extend; Index++ )
          {
            Atom = createvexatomvec( Value, Expr->LEFT, Expr->LEFT );
            addvexhexpr( Result, Atom );
          }

          Expr = Result;

          Expr->WIDTH = Width;
          Expr->LEFT  = Width - 1;
          Expr->RIGHT = 0;

          SetVexNodeSigned( Expr );
        }
        else
        {
          Target = 0;

          if ( Extend > 1 ) Limit = '"';
          else              Limit = '\'';

          Buffer[ Target++ ] = Limit;

          for ( Index = 1; Index <= Extend; Index++ )
          {
            Buffer[ Target++ ] = '0';
          }

          Buffer[ Target++ ] = Limit;
          Buffer[ Target++ ] = '\0';

          Atom = createvexatomlit( Buffer );
          Expr = createvexbinexpr( VEX_CONCAT, 0, Atom, Expr );

          Expr->LEFT  = Width - 1;
          Expr->RIGHT = 0;
          Expr->WIDTH = Width;
        }

        return( Expr );
      }
      else
      {
/*
** May be one day ... !
*/
      }
    }
  }

  return( (vexexpr *)0 );
}
