/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vex                           |
|                                                             |
| File    :                  vexfree.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H

# include <stdio.h>
# include <string.h>
# include "vexfree.h"
# include "vexerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     Vex Free Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Vex Free Node                        |
|                                                             |
\------------------------------------------------------------*/

void freevexnode( Node )

  vexexpr *Node;
{
  autfreeheap( Node, sizeof( Node ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Vex Free Expr                        |
|                                                             |
\------------------------------------------------------------*/

void freevexexpr( Expr )

  vexexpr *Expr;
{
  chain_list *ScanOper;

  if ( Expr != (vexexpr *)0 )
  {
    if ( ! IsVexNodeAtom( Expr ) )
    {
      for ( ScanOper  = Expr->OPERAND;
            ScanOper != (chain_list *)0;
            ScanOper  = ScanOper->NEXT )
      {
        freevexexpr( GetVexOperand( ScanOper ) );
      }

      freechain( Expr->OPERAND );
    }

    freevexnode( Expr );
  }
}
