/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vex                           |
|                                                             |
| File    :                 vexslice.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H

# include <stdio.h>
# include <string.h>
# include "vexslice.h"
# include "vexerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char VexBuffer[ 128 ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Slice Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Slice Vex Atom Vector                  |
|                                                             |
\------------------------------------------------------------*/

vexexpr *slicevexatomvec( Expr, Left, Right )

  vexexpr *Expr;
  short    Left;
  short    Right;
{
  short   Width;
  short   PosLeft;
  short   PosRight;
  short   PosMin;
  short   PosMax;
  char    Separ;

/*\
fprintf( stdout, "slicevexatomvec %d %d\n", Left, Right );
viewvexexprbound( Expr );
fprintf( stdout, " --> " );
\*/

  if ( ( IsVexNodeAtom( Expr   ) ) &&
       ( IsVexAtomVector( Expr ) ) )
  {
    PosLeft  = getvexvectorpos( Expr, Left  );
    PosRight = getvexvectorpos( Expr, Right );

    if ( ( PosLeft  >= 0 ) &&
         ( PosRight >= 0 ) )
    {
      if ( Left < Right )
      {
        Width = 1 + Right - Left;
        SetVexAtomUp( Expr );
      }
      else
      {
        Width = 1 + Left  - Right;
        SetVexAtomDown( Expr );
      }
  
      if ( IsVexAtomLiteral( Expr ) )
      {
        if ( Width == 1 ) Separ = '\'';
        else              Separ = '"';
  
        if ( PosLeft > PosRight )
        {
          PosMin = PosRight;
          PosMax = PosLeft;
        }
        else
        {
          PosMin = PosLeft;
          PosMax = PosRight;
        }
  
        strcpy( VexBuffer, GetVexAtomValue( Expr ) );
        VexBuffer[ PosMin     ] = Separ;
        VexBuffer[ PosMax + 2 ] = Separ;
        VexBuffer[ PosMax + 3 ] = '\0';
  
        SetVexAtomValue( Expr, namealloc( &VexBuffer[ PosMin ] ) );
      }

      Expr->LEFT  = Left;
      Expr->RIGHT = Right;
      Expr->WIDTH = Width;
/*\
viewvexexprbound( Expr );
fprintf( stdout, "\n" );
\*/
      return( Expr );
    }
  }

  return( (vexexpr *)0 );
}
