/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vex                           |
|                                                             |
| File    :                   vexunflat.c                     |
|                                                             |
| Date    :                   03.12.99                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H

# include <stdio.h>
# include "vexunflat.h"
# include "vexerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Varivexes                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Unflat Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Unflat Vex Expr                       |
|                                                             |
\------------------------------------------------------------*/

vexexpr *unflatvexexpr( Expr )

  vexexpr *Expr;
{
  vexexpr    *ScanExpr;
  chain_list *ScanChain;
  long        Oper;

  if ( ( Expr == (vexexpr *)0  ) ||
       ( IsVexNodeAtom( Expr ) ) )
  {
    return( Expr );
  }


  if ( IsVexNodeOper( Expr ) )
  {
    Oper = GetVexOperValue( Expr );

    if ( ( Oper == VEX_OR   ) ||
         ( Oper == VEX_AND  ) ||
         ( Oper == VEX_XOR  ) ||
         ( Oper == VEX_NOR  ) ||
         ( Oper == VEX_NAND ) ||
         ( Oper == VEX_NXOR ) ||
         ( Oper == VEX_ADD  ) ||
         ( Oper == VEX_MUL  ) )
    {
      if ( Expr->OPERAND->NEXT->NEXT != (chain_list *)0 )
      {
        if ( isvexnegativeoper( Oper ) )
        {
          Oper = getvexnotoper( Oper );
          SetVexOperValue( Expr, Oper );

          ScanExpr = createvexoper( VEX_NOT, Expr->WIDTH );
          addvexhexpr( ScanExpr, Expr );
          Expr = ScanExpr;
        }
        else
        {
          ScanExpr = createvexoper( Oper, Expr->WIDTH );
          ScanExpr->OPERAND = Expr->OPERAND->NEXT;
          Expr->OPERAND->NEXT = addchain( (chain_list *)0, (void *)ScanExpr );
        }
      }
    }
  }

  for ( ScanChain  = Expr->OPERAND;
        ScanChain != (chain_list *)0;
        ScanChain  = ScanChain->NEXT )
  {
    ScanExpr = GetVexOperand( ScanChain );
    ScanExpr = unflatvexexpr( ScanExpr );
    SetVexOperand( ScanChain, ScanExpr );
  }

  return( Expr );
}
