/*------------------------------------------------------------\
|                                                             |
| Tool    :                     VPN                           |
|                                                             |
| File    :                   vpnsimp.c                       |
|                                                             |
| Author  :                 Jacomme Ludovic                   |
|                                                             |
| Date    :                   01.01.95                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H

# include "vpnerror.h"
# include "vpnsimp.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Private Variables                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        simpvpnact                           |
|                                                             |
\------------------------------------------------------------*/

void simpvpnact( VpnAct )

  vpnact_list *VpnAct;
{
  VpnAct->VEX_ATOM = simpvexexpr( VpnAct->VEX_ATOM );
  VpnAct->VEX_EXPR = simpvexexpr( VpnAct->VEX_EXPR );
}

/*------------------------------------------------------------\
|                                                             |
|                        simpvpntrans                         |
|                                                             |
\------------------------------------------------------------*/

void simpvpntrans( VpnTrans )

  vpntrans_list *VpnTrans;
{
  vpnact_list *VpnAct;

  VpnTrans->VEX_GUARD = simpvexexpr( VpnTrans->VEX_GUARD );

  for ( VpnAct  = VpnTrans->ACT;
        VpnAct != (vpnact_list *)0;
        VpnAct  = VpnAct->NEXT )
  {
    simpvpnact( VpnAct );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        simpvpnfunc                          |
|                                                             |
\------------------------------------------------------------*/

void simpvpnfunc( VpnFunc )

  vpnfunc_list *VpnFunc;
{
  vpntrans_list *VpnTrans;

  for ( VpnTrans  = VpnFunc->TRANS;
        VpnTrans != (vpntrans_list *)0;
        VpnTrans  = VpnTrans->NEXT )
  {
    simpvpntrans( VpnTrans );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        simpvpnproc                          |
|                                                             |
\------------------------------------------------------------*/

void simpvpnproc( VpnProc )

  vpnproc_list *VpnProc;
{
  vpntrans_list *VpnTrans;

  for ( VpnTrans  = VpnProc->TRANS;
        VpnTrans != (vpntrans_list *)0;
        VpnTrans  = VpnTrans->NEXT )
  {
    simpvpntrans( VpnTrans );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        simpvpnfig                           |
|                                                             |
\------------------------------------------------------------*/

void simpvpnfig( VpnFigure )

  vpnfig_list *VpnFigure;
{
  vpnproc_list *VpnProc;
  vpnfunc_list *VpnFunc;

  for ( VpnProc  = VpnFigure->PROCESS;
        VpnProc != (vpnproc_list *)0;
        VpnProc  = VpnProc->NEXT )
  {
    simpvpnproc( VpnProc );
  }

  for ( VpnFunc  = VpnFigure->FUNCTION;
        VpnFunc != (vpnfunc_list *)0;
        VpnFunc  = VpnFunc->NEXT )
  {
    simpvpnfunc( VpnFunc );
  }
}
