/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vtl                           |
|                                                             |
| File    :                  vtlacces.c                       |
|                                                             |
| Date    :                   04.07.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H
# include VTL_H

# include "vtlacces.h"
# include "vtlerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char *VPN_IN;
  char *VPN_OUT;

  char *VPN_VHDL_FORMAT = (char *)0;
  char *VPN_VPN_FORMAT  = (char *)0;
  char *VPN_VBE_FORMAT  = (char *)0;
  char *VPN_SYN_FORMAT  = (char *)0;
  char *VPN_FSM_FORMAT  = (char *)0;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            vpnenv                           |
|                                                             |
\------------------------------------------------------------*/

void vpnenv()
{
  VPN_IN = namealloc( getenv( "VPN_IN") );

  if ( VPN_IN == (char *)0 )
  {
    VPN_IN = namealloc( VTL_DEFAULT_IN );
  }
 
  VPN_OUT = namealloc( getenv( "VPN_OUT") );

  if ( VPN_OUT == (char *)0 )
  {
    VPN_OUT = namealloc( VTL_DEFAULT_OUT );
  }

  VPN_VHDL_FORMAT = namealloc( "vhdl" );
  VPN_VPN_FORMAT  = namealloc( "vpn"  );
  VPN_SYN_FORMAT  = namealloc( "vhd"  );
  VPN_VBE_FORMAT  = namealloc( "vbe"  );
  VPN_FSM_FORMAT  = namealloc( "fsm"  );
}

/*------------------------------------------------------------\
|                                                             |
|                          loadvpnfig                         |
|                                                             |
\------------------------------------------------------------*/

void loadvpnfig( Figure, Name, Reduced )

  vpnfig_list *Figure;
  char        *Name;
  int          Reduced;
{
  if ( ( VPN_IN == VPN_VHDL_FORMAT ) ||
       ( VPN_IN == VPN_SYN_FORMAT  ) ||
       ( VPN_IN == VPN_FSM_FORMAT  ) ||
       ( VPN_IN == VPN_VBE_FORMAT  ) )
  {
    vhdlloadvpnfig( Figure, Name, Reduced );
  }
  else
  if ( VPN_IN == VPN_VPN_FORMAT )
  {
    vpnloadvpnfig( Figure, Name );
  }
  else
  {
    vtlerror( VTL_UNKNOWN_VPN_IN, VPN_IN );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                          savevpnfig                         |
|                                                             |
\------------------------------------------------------------*/

void savevpnfig( Figure )

  vpnfig_list *Figure;
{
  if ( VPN_OUT == VPN_VHDL_FORMAT )
  {
    vhdlsavevpnfig( Figure );
  }
  else
  if ( VPN_OUT == VPN_VPN_FORMAT )
  {
    vpnsavevpnfig( Figure );
  }
  else
  {
    vtlerror( VTL_UNKNOWN_VPN_OUT, VPN_OUT );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                          getvpnfig                          |
|                                                             |
\------------------------------------------------------------*/

vpnfig_list *getvpnfig( Name )

   char *Name;
{
  vpnfig_list *Figure;
  char        *FigName;

  FigName = namealloc( Name );

  for ( Figure  = HEAD_VPNFIG;
        Figure != (vpnfig_list *)0;
        Figure  = Figure->NEXT )
  {
    if ( Figure->NAME == FigName ) break;
  }

  if ( Figure == (vpnfig_list *)0 )
  {
    Figure = addvpnfig( Name );

    loadvpnfig( Figure, Name, 1 );
  }

  return( Figure );
}
