/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                            |
|                                                             |
| File    :                   Fsm.c                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <signal.h>
# include <string.h>
# include <setjmp.h>
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include FTL_H
# include XSB_H 
# include XFS_H
# include "XFS_fsm.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  fsmfig_list  *XfsmFigureFsm = (fsmfig_list  *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                       For Set Long Jump                     |
|                                                             |
\------------------------------------------------------------*/

  static jmp_buf XfsmJumpBuffer;
  static void    (*OldExitHandler)() = NULL;

/*------------------------------------------------------------\
|                                                             |
|                           Functions                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                 Xfsm Exit Handler Functions                 |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XfsmExitHandler                        |
|                                                             |
\------------------------------------------------------------*/

void XfsmExitHandler()
{
  XfsmFlushErrorMessage();

  signal( SIGTERM, OldExitHandler );
  longjmp( XfsmJumpBuffer, 1);
}

/*------------------------------------------------------------\
|                                                             |
|                      XfsmActiveExitHandler                  |
|                                                             |
\------------------------------------------------------------*/

void XfsmActiveExitHandler()
{
  OldExitHandler = signal( SIGTERM, XfsmExitHandler );
}

/*------------------------------------------------------------\
|                                                             |
|                       XfsmResetExitHandler                  |
|                                                             |
\------------------------------------------------------------*/

void XfsmResetExitHandler()
{
  signal( SIGTERM, OldExitHandler );
}

/*------------------------------------------------------------\
|                                                             |
|                          Get Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Xfsmgetfsmfig                      |
|                                                             |
\------------------------------------------------------------*/

fsmfig_list *Xfsmgetfsmfig( FileName )

  char *FileName;
{
  fsmfig_list *FigureFsm;

  autbegin();

  FigureFsm = (fsmfig_list *)NULL;

  XfsmActiveExitHandler();

  if ( setjmp( XfsmJumpBuffer ) == 0 )
  {
    FigureFsm = getfsmfig( FileName );

    XfsmResetExitHandler();

    autend();
    return( FigureFsm );
  }

  if ( FigureFsm != (fsmfig_list *)NULL )
  {
    delfsmfig( FigureFsm->NAME );
  }

  autend();
  return( (fsmfig_list *)NULL );
}
