/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                           |
|                                                             |
| File    :                   View.h                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef XFSM_VIEW
# define XFSM_VIEW

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define XFSM_PERCENT_ZOOM      30
# define XFSM_PERCENT_ZOOM_MIN   5
# define XFSM_PERCENT_ZOOM_MAX  95

# define XFSM_PERCENT_MOVE      30
# define XFSM_PERCENT_MOVE_MIN   5
# define XFSM_PERCENT_MOVE_MAX  95

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/

  typedef struct xfsmzoom
   {
     struct xfsmzoom *NEXT;

     long              X;
     long              Y;
     long             DX;
     long             DY;

   } xfsmzoom;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern int            XfsmPercentZoom;
  extern int            XfsmPercentMove;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void XfsmZoomUndo();
  extern void XfsmZoomRefresh();

  extern void XfsmZoomLeft();
  extern void XfsmZoomRight();
  extern void XfsmZoomUp();
  extern void XfsmZoomDown();

  extern void XfsmZoomMore();
  extern void XfsmZoomLess();

  extern void XfsmZoomFit();

# endif 
