/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                            |
|                                                             |
| File    :                   Icon.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/PushB.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
 
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include XSB_H
# include XTB_H
# include XMX_H

# include "XMX_icon.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char IconBits[] = 

  {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x60, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
  0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x40, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x16, 0x40, 0x03, 0x00, 0x00, 0x00, 0x00, 0x11, 0x40, 0x04, 0x00, 0x00,
  0x00, 0x80, 0x60, 0x30, 0x08, 0x00, 0x00, 0x00, 0x40, 0x80, 0x0f, 0x10,
  0x00, 0x00, 0x00, 0x20, 0x00, 0x02, 0x20, 0x00, 0x00, 0x00, 0x20, 0x00,
  0x07, 0x20, 0x00, 0x00, 0x00, 0x10, 0x80, 0x0f, 0x40, 0x00, 0x00, 0x00,
  0x10, 0x40, 0x12, 0x40, 0x00, 0x00, 0x00, 0x10, 0x00, 0x02, 0x40, 0x00,
  0x00, 0x00, 0x08, 0x00, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x00, 0x02,
  0x80, 0x00, 0x00, 0x00, 0x08, 0x00, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08,
  0x00, 0x02, 0x80, 0x00, 0x00, 0x00, 0x08, 0x00, 0x02, 0x80, 0x00, 0x00,
  0x00, 0x04, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x04, 0x00, 0x01, 0x00,
  0x01, 0x00, 0x00, 0x04, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x04, 0x00,
  0x01, 0x00, 0x01, 0x00, 0x80, 0x24, 0x80, 0x00, 0x20, 0x09, 0x00, 0x00,
  0x1f, 0x80, 0x00, 0xc0, 0x07, 0x00, 0x00, 0x0e, 0x40, 0x00, 0x80, 0x03,
  0x00, 0x00, 0x04, 0x20, 0x00, 0x00, 0x01, 0x00, 0x00, 0x1f, 0x18, 0x00,
  0xc0, 0x07, 0x00, 0xc0, 0x60, 0x07, 0x00, 0x30, 0x18, 0x00, 0x20, 0x80,
  0x00, 0x00, 0x08, 0x20, 0x00, 0x20, 0x80, 0x10, 0x40, 0x08, 0x20, 0x00,
  0x10, 0x00, 0x09, 0x80, 0x04, 0x40, 0x00, 0x10, 0x00, 0x0d, 0x80, 0x05,
  0x40, 0x00, 0x10, 0x00, 0xff, 0xff, 0x07, 0x40, 0x00, 0x10, 0x00, 0x0d,
  0x80, 0x05, 0x40, 0x00, 0x10, 0x00, 0x09, 0x80, 0x04, 0x40, 0x00, 0x20,
  0x80, 0x10, 0x40, 0x08, 0x20, 0x00, 0x20, 0x80, 0x00, 0x00, 0x08, 0x20,
  0x00, 0xc0, 0x60, 0x00, 0x00, 0x30, 0x18, 0x00, 0x00, 0x1f, 0x00, 0x00,
  0xc0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, };

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    XfsmInitializeIcon                      |
|                                                             |
\------------------------------------------------------------*/

void XfsmInitializeIcon()

{
  autbegin();

  XfsmSetIcon( XfsmTopLevel, 
                IconBits, IconWidth, IconHeight );

  autend();
}
