/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XFSM                           |
|                                                             |
| File    :                  Share.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <Xm/Xm.h>

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include XSB_H
# include "XSB_share.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char XFSM_ACTIVE_NAME_TABLE [ XFSM_MAX_ACTIVE_NAME ] = 
  {
    1, /* PLACE TEXT  */
    1  /* PLACE TRANS */
  };

  char XFSM_ACTIVE_LAYER_TABLE [ XFSM_MAX_LAYER ] = 
  {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  };

  char *XfsmFirstFileName  = (char *)NULL;
  char *XFSM_XMS_FILE_NAME = (char *)NULL;

  char XFSM_FORCE_DISPLAY = XFSM_FALSE;
  char XFSM_XOR_CURSOR    = XFSM_FALSE;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XfsmPostTreatString                    |
|                                                             |
\------------------------------------------------------------*/

char *XfsmPostTreatString( Text )

  char *Text;
{
  char OnlySpace;
  int  Counter;

  autbegin();

  if ( Text != (char *)NULL )
  {
    OnlySpace = 1;

    for ( Counter = 0; Text[ Counter ]; Counter++ )
    {
      if ( Text[ Counter ] != ' ' ) OnlySpace = 0;
    }

    if ( OnlySpace ) Text = (char *)NULL;
  }

  autend();
  return( Text );
}

/*------------------------------------------------------------\
|                                                             |
|                        Xfsmgetenv                           |
|                                                             |
\------------------------------------------------------------*/

void Xfsmgetenv()
{
  char *Env;

  Env = getenv( "HOME" );

  if ( Env == (char *)NULL )
  {
    XFSM_XMS_FILE_NAME = XMS_FILE_NAME;
  }
  else
  {
    XFSM_XMS_FILE_NAME =

     (char *)autallocblock( strlen( Env ) + strlen( XMS_FILE_NAME ) + 2 );

    strcpy( XFSM_XMS_FILE_NAME, Env );
    strcat( XFSM_XMS_FILE_NAME, "/" );
    strcat( XFSM_XMS_FILE_NAME, XMS_FILE_NAME );
  }
}
