/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XPAT                           |
|                                                             |
| File    :                   View.h                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef XPAT_VIEW
# define XPAT_VIEW

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define XPAT_PERCENT_ZOOM      15
# define XPAT_PERCENT_ZOOM_MIN   5
# define XPAT_PERCENT_ZOOM_MAX  95

# define XPAT_PERCENT_MOVE      15
# define XPAT_PERCENT_MOVE_MIN   5
# define XPAT_PERCENT_MOVE_MAX  95

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/

  typedef struct xpatzoom
   {
     struct xpatzoom *NEXT;

     long              X;
     long              Y;
     long             DX;
     long             DY;

   } xpatzoom;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern int            XpatPercentZoom;
  extern int            XpatPercentMove;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void XpatZoomUndo();
  extern void XpatZoomRefresh();

  extern void XpatZoomLeft();
  extern void XpatZoomRight();
  extern void XpatZoomUp();
  extern void XpatZoomDown();

  extern void XpatZoomMore();
  extern void XpatZoomLess();

  extern void XpatZoomFit();

# endif 
