/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XPAT                           |
|                                                             |
| File    :                  Share.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <Xm/Xm.h>

# include MUT_H
# include AUT_H
# include PAT_H
# include XSB_H
# include "XSB_share.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char XPAT_ACTIVE_NAME_TABLE [ XPAT_MAX_ACTIVE_NAME ] = 
  {
    1, /* PATTERN TEXT */
    1  /* IO      TEXT */
  };

  char XPAT_ACTIVE_LAYER_TABLE [ XPAT_MAX_LAYER ] = 
  {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  };

  char *XpatFirstFileName  = (char *)NULL;
  char *XPAT_XMS_FILE_NAME = (char *)NULL;

  char XPAT_FORCE_DISPLAY = XPAT_FALSE;
  char XPAT_XOR_CURSOR    = XPAT_FALSE;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XpatPostTreatString                    |
|                                                             |
\------------------------------------------------------------*/

char *XpatPostTreatString( Text )

  char *Text;
{
  char OnlySpace;
  int  Counter;

  autbegin();

  if ( Text != (char *)NULL )
  {
    OnlySpace = 1;

    for ( Counter = 0; Text[ Counter ]; Counter++ )
    {
      if ( Text[ Counter ] != ' ' ) OnlySpace = 0;
    }

    if ( OnlySpace ) Text = (char *)NULL;
  }

  autend();
  return( Text );
}

/*------------------------------------------------------------\
|                                                             |
|                        Xpatgetenv                           |
|                                                             |
\------------------------------------------------------------*/

void Xpatgetenv()
{
  char *Env;

  Env = getenv( "HOME" );

  if ( Env == (char *)NULL )
  {
    XPAT_XMS_FILE_NAME = XMS_FILE_NAME;
  }
  else
  {
    XPAT_XMS_FILE_NAME =

     (char *)autallocblock( strlen( Env ) + strlen( XMS_FILE_NAME ) + 2 );

    strcpy( XPAT_XMS_FILE_NAME, Env );
    strcat( XPAT_XMS_FILE_NAME, "/" );
    strcat( XPAT_XMS_FILE_NAME, XMS_FILE_NAME );
  }
}
