/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                           |
|                                                             |
| File    :                   Map.h                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef XSCH_MAP
# define XSCH_MAP

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define XSCH_B1UP   0
# define XSCH_B2UP   1
# define XSCH_B3UP   2

# define XSCH_VIEW_MAP_X        25
# define XSCH_VIEW_MAP_Y       520

# define XSCH_DEFAULT_MAP_X      0
# define XSCH_DEFAULT_MAP_Y      0
# define XSCH_DEFAULT_MAP_DX    40
# define XSCH_DEFAULT_MAP_DY    40

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
 
  extern Widget XschMapPanel;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void XschComputeUnitMap();
  extern void XschInitializeUnitMap();
  extern void XschDisplayUnitMap();

  extern void XschEnterMapPanel();
  extern void XschClearMapWindow();
  extern void XschResizeMapWindow();
  extern void XschRefreshMapWindow();
  extern void XschInitializeMapWindow();

  extern void CallbackCloseMap();
  extern void CallbackMapCompute();
  extern void CallbackMapResize();
  extern void CallbackMapExpose();
  extern void CallbackMapEvent();

# endif 
