/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                            |
|                                                             |
| File    :                   Icon.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/PushB.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
 
# include MUT_H
# include AUT_H
# include MLO_H
# include XSB_H
# include XTB_H
# include XMX_H

# include "XMX_icon.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char IconBits[] = 

  {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x7f,
    0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x1f,
    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x00, 0x00, 0x00,
    0x00, 0x10, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0xc0, 0x03,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x04, 0x00, 0x00, 0x00, 0x10, 0x00,
    0x40, 0xfc, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x84, 0x00, 0x00, 0x00,
    0x10, 0x00, 0xc0, 0x83, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x80, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x40, 0x80, 0xf8, 0xff, 0x00, 0x10, 0x00, 0x40,
    0x80, 0x08, 0x80, 0x00, 0x1f, 0x00, 0x40, 0x80, 0x08, 0x80, 0x00, 0x10,
    0x00, 0x40, 0x80, 0x08, 0x80, 0x00, 0x10, 0x00, 0x40, 0x80, 0x08, 0x80,
    0x00, 0xf0, 0xff, 0x7f, 0x80, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x80, 0x08, 0x80, 0x00, 0x00, 0x00,
    0x00, 0x80, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x80, 0x00,
    0x00, 0x00, 0x00, 0x80, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x80, 0x08,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x80, 0x08, 0x80, 0x00, 0xf0, 0xff, 0x7f,
    0x80, 0x08, 0x80, 0x00, 0x10, 0x00, 0x40, 0x80, 0x08, 0x80, 0x00, 0x10,
    0x00, 0x40, 0x80, 0x08, 0x80, 0x00, 0x1f, 0x00, 0x40, 0x80, 0xf8, 0xff,
    0x00, 0x10, 0x00, 0x40, 0x80, 0x00, 0x00, 0x00, 0x10, 0x00, 0xc0, 0x83,
    0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x84, 0x00, 0x00, 0x00, 0x10, 0x00,
    0x40, 0xfc, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x40, 0x04, 0x00, 0x00, 0x00,
    0x10, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40,
    0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x10,
    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x40, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00
  };

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    XschInitializeIcon                      |
|                                                             |
\------------------------------------------------------------*/

void XschInitializeIcon()

{
  autbegin();

  XschSetIcon( XschTopLevel, 
                IconBits, IconWidth, IconHeight );

  autend();
}
