/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XVPN                            |
|                                                             |
| File    :                  xvpn.c                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

# ident "@(#)XVPN ver 1.01 September 1996"

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include <Xm/Xm.h>
# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H
# include VTL_H
# include XSB_H
# include XVP_H
# include XMX_H

# include "xvpn.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                           present                           |
|                                                             |
\------------------------------------------------------------*/

void XvpnPresent()
{
  alliancebanner_with_authors( "Xvpn", XVPN_VERSION,
                  "Graphic Petri Nets Viewer", "1996",
                  ALLIANCE_VERSION, "Ludovic Jacomme" );
}

/*------------------------------------------------------------\
|                                                             |
|                            main                             |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

    int   argc;
    char *argv[];
{
  char  Debug = 0;
  int   Index;
 
  XvpnPresent();

  mbkenv();
  autenv();
  vexenv();
  vpnenv();
  Xvpngetenv();

  for ( Index = 1;
        Index < argc;
        Index++ )
  {
    if ( ! strcmp( argv[ Index ], "-l" ) )
    {
      if ( ( Index + 1 ) < argc )
      {
        Index             = Index + 1;
        XvpnFirstFileName = argv[ Index ];
      }
    }
    else
    if ( ! strcmp( argv[ Index ], "-debug" ) )
    {
      Debug = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-elaborate" ) )
    {
      XvpnElaborate = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-bdd" ) )
    {
      XvpnBdd = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-bound" ) )
    {
      XvpnBound = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-simp" ) )
    {
      XvpnSimp = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-noreduce" ) )
    {
      XvpnReduce = 0;
    }
    else
    if ( ! strcmp( argv[ Index ], "-reduce_after" ) )
    {
      XvpnReduceAfter = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-I" ) )
    {
      Index  = Index + 1;
      VPN_IN = namealloc( argv[ Index ] );
    }
  }

  if ( Debug ) autdebug();

  autbegin();

  XvpnLoadParameters();

  XvpnInitializeRessources( &argc, argv );
  XvpnInitializeErrorMessage( Debug );

  XtAppMainLoop( XvpnApplication ); 

  autend();

  return( 0 );
}
